#ifndef XMLBLOBCONTENTHANDLERS_HXX
#define XMLBLOBCONTENTHANDLERS_HXX

#include <string>
#include <stack>
#include <sax2/DefaultHandler.hpp>

#include "XmlContent.hxx"
#include "Sptr.hxx"
#include "VException.hxx"
#include "PSDBCommonType.h"
#include "PSBlobResult.hxx"

///
class XmlBlobContentHandler : public DefaultHandler
{
public:

  ///
  XmlBlobContentHandler() {}
  ///
  XmlBlobContentHandler(Sptr<PSBlobResult> result);

  ///
  virtual ~XmlBlobContentHandler();

  ///
  void startDocument();
  
  ///
  void startElement(const XMLCh* const uri,
		    const XMLCh* const localname,
		    const XMLCh* const qname,
		    const Attributes& attributes);

  ///
  void characters(const XMLCh* const chars, const unsigned int length);

  ///
  void endElement(const XMLCh* const uri, 
		  const XMLCh* const localname, 
		  const XMLCh* const qname);
  
  ///
  void endDocument();

  ///
  void ignorableWhitespace(const XMLCh* const chars,
			   const unsigned int length)
    {}

  ///
  void warning(const SAXParseException& exception);
  ///
  void error(const SAXParseException& exception);
  ///
  void fatalError(const SAXParseException& exception);

  ///
  void notationDecl(const XMLCh* const name,
		    const XMLCh* const publicId,
		    const XMLCh* const systemId)
    {}

  ///
  void unparsedEntityDecl(const XMLCh* const name,
			  const XMLCh* const publicId,
			  const XMLCh* const systemId,
			  const XMLCh* const notationName)
    {}



private :

    /// parsing helper: name of element last reported is always at the top
    stack< string > myFields;
    string myChars;

    Sptr<PSBlobResult> myParsedContent;
    int level;
    int index;

};


#endif // XMLBLOBCONTENTHANDLER_HXX
