/* ====================================================================
 * The Vovida Software License, Version 1.0
 *
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * ====================================================================
 *
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const SetRecord_cxx  = "$Id: SetRecords.cxx,v 1.2 2001/09/17 23:32:15 maivu Exp $";

#include "Util.h"
#include <map>

void SetRecords(ProvisioningInterface& pif)
{
    GetFields(pif);

    tableType aTable;
    ReadTableRequest(aTable);

    string filterRule;
    ReadFilterRule(filterRule);
/*
    map<string, string> a;
    //a["vocalcs"] = "<level1><level2>aksjdfljdl</level2><level2><level3><level4>kadfj</level4><level4>kdfjld</level4></level3><level3>ajfkdg</level3></level2></level1>";

   a["RASTechPrefix"] = "<table>\r\n<row>\r\n<DialedNumber>1919321....</DialedNumber>\r\n<TechPrefix>001#</TechPrefix>\r\n<Action>INCLUDE</Action>\r\n</row>\r\n<row>\r\n<DialedNumber>1919456....</DialedNumber>\r\n<TechPrefix>002#</TechPrefix>\r\n<Action>STRIP</Action>\r\n</row>\r\n</table>";
*/
    Sptr<PSDBResult> result = 0;
    try
      {
	result = pif.setRecordsInDomain(domain, filterRule, aTable);
	//result = pif.setRecordsInDomain("Carafe", "(hostport='*')", a);
      }
    catch (VException& e)
      {
	cout << "Error from Set Records in Domain: "
	     << e.getDescription() << endl;
	cout << "Stop !!!" << endl;
	return;
      }
    
    cout << "====================================" << endl;
    cout << "===> SetRecordsInDomain  Result <===" << endl;
    cout << "====================================" << endl;
    string error = result->getError();
    if (error.size() != 0)
      {
	cout << "- Error: " << error << ". Stop !!!" << endl;
	return;
      }
    cout << "- Result Count = " << result->getNumMatches() << endl;
    
    return;
}
