#ifndef UTIL_H
#define UTIL_H

/* ====================================================================
 * The Vovida Software License, Version 1.0
 *
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * ====================================================================
 *
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const Util_h = "$Id: Util.h,v 1.1.1.1 2001/08/21 23:30:24 dabryan Exp $";


#include <string>
#include "cpLog.h"
#include "ProvisioningInterface.hxx"
#include "PSIFCreator.hxx"
#include "CommandLine.hxx"
#include "Data.hxx"
#include "PSDBResult.hxx"
#include "PSDBCommonType.h"



extern FieldListtype fieldList;
extern string sessionID;
extern string domain;
extern int sessionSearchResultCount;
extern bool isSessionOpen;
extern string filter;

void ReadHostPort(string& hostport);
void ReadDomain();
void ReadFieldListRequest(FieldListtype & aList);
void ReadFilterRule(string & filterRule);
void ReadTableRequest(tableType & aTable);
void PrintFieldList();
void PrintGetResult(Sptr<PSDBResult> result);
void ReadKeyList(vector<string>& keyList);



int GetFields(ProvisioningInterface& pif);
void GetRecords(ProvisioningInterface& pif);
void SetRecords(ProvisioningInterface& pif);
void AddRecords(ProvisioningInterface& pif);
void DeleteRecords(ProvisioningInterface& pif);


void SessionOpen(ProvisioningInterface& pif);
void SessionClose(ProvisioningInterface& pif);
void SessionSearchDB(ProvisioningInterface& pif);
void SessionGetDBResult(ProvisioningInterface& pif);
void SessionSetDBResult(ProvisioningInterface& pif);
void SessionSortDBResult(ProvisioningInterface& pif);
void SessionDeleteAll(ProvisioningInterface& pif);

void RegisterDomain(ProvisioningInterface& pif);
void RegisterRecord(ProvisioningInterface& pif);
void UpdateRecord(const string&, const vector<string>& keyList);
void UnRegisterDomain(ProvisioningInterface& pif);
void UnRegisterRecord(ProvisioningInterface& pif);
void callback1(const string&, const vector<string>& keyList);
void callback2(const string&, const vector<string>& keyList);
void callback3(const string&, const vector<string>& keyList);
void callback4(const string&, const vector<string>& keyList);


#endif // UITL_H
