// DBInfo.cxx


#include <stdio.h>
#include "DBInfo.h"
#include <parse3tuple.h>


typedef enum
{
    DBConnection,
    database,
    host,
    port,
    user,
    password,
    dn,
    dbInfoTagMax
}  DbInfoTags;    

static const char* DbInfoTagsString [] =
{
    "DBConnection",
    "database",
    "host",
    "port",
    "user",
    "password",
    "dn",
    "Unknown"
};

//global
static DBInfo info;

void parseConfigCallback(char* tag, char* type, char* value)
{
    switch(strConst2i(tag,
		      DbInfoTagsString,
		      dbInfoTagMax))
    {
      case DBConnection:
        {
	  info.dbBackend = value;
        }
        break;
      case database:
        {
	  info.database = value ;
        }
        break;
      case host:
        {
	  info.host =  value;
        }
        break;
      case port:
        {
	  int i;
	  sscanf( value, "%d", &i );
	  info.port = i;
        }
        break;
      case user:
        {
	  info.user = value;
        }
        break;
      case password:
        {
	  info.password = value;
        }
        break;
      case dn:
        {
	  info.dn = value;
        }
        break;
      default:
        {
	  cerr << "Unknown Tag: " << tag << endl;
        }
      }
}

DBInfo parseConfigFile()
{
    string configFile = "dbcreate.cfg";

    FILE* fd = fopen (configFile.c_str(), "r");
    if (fd == NULL)
      {
	cerr << "\n\nERROR : No such file exists: " << configFile.c_str() 
	     << ". Exit(0)" << endl << endl;
	exit(0);
      }
    fclose(fd);

    parse3tuple(configFile.c_str(), parseConfigCallback);

    return info;
}



// end of file
