#ifndef DBRESULTSET_HXX
#define DBRESULTSET_HXX

#include <string>
#include <vector>
#include <map>
#include "DBTypes.h"


/// DBResultset class- encapsulate database query results
class DBResultset
{
    public:
        /// Constructor
        DBResultset(){};

        /// Destructor
        virtual ~DBResultset(){};

        /// Return all records from a query
        virtual const ResultTabletype& GetRecords(void) const = 0;

        /// Return records between offset1 and offset2
        virtual const ResultTabletype& GetRecords(unsigned short offset1, 
                unsigned short offset2) const = 0;

        /// Return the record at [offset]
        virtual const ResultRecordtype& operator[](unsigned short offset)
            const = 0;

        /// Return the record at offset
        virtual const ResultRecordtype& GetRecord(unsigned short offset)
            const = 0;

        /// Return field list from query
        virtual const FieldListtype& GetFields(void) const = 0;

        /// Return number of records in query
        virtual const unsigned int GetRecordCount(void) const = 0;

        /// Return search filter from query
        virtual const string& GetSearchFilter(void) const = 0;
};
#endif
