#ifndef LDAPFILTERPARSER_HXX
#define LDAPFILTERPARSER_HXX

#include <vector>
#include <stack>
#include <string>
#include <strstream>
#include "Filterscanner.hxx"
 
/// LDAPFilterparser class- 
class LDAPFilterparser
{
    private:
        ///
        Scanner myScanner;

        ///
        Token* myTokenP;

        ///
        TokenCode myTokencode;

        ///
        string myTokenstring;
 
        ///
        char myLDAPsearchclause[256];

        ///
        ostrstream myLDAPsearchclausestrm;

        ///
        void Parse(void);

        ///
        void ParseFilter(void);

        ///
        void ParseFilterComposition(void);

        ///
        void ParseFilterList(void);

        ///
        void ParseItem(void);

        ///
        void ParseValue(void);

        ///
        void ParseStarValue(void);

        ///
        void GetToken(void);

    public:
        ///
        LDAPFilterparser(const string& filterbuffer);
 
        ///
        virtual ~LDAPFilterparser(void){}

        ///
        virtual const char* GetParsedresult(void);
};
 
#endif
