#ifndef LDAPRESULTSET_HXX
#define LDAPRESULTSET_HXX

#include <lber.h>
#include <ldap.h>
#include "DBResultset.hxx"

///
class LDAPResultset : public DBResultset
{
    private:
        ///
        LDAPResultset(LDAPMessage* result, LDAP* handle, 
                const string& searchfilter);

        ///
        virtual ~LDAPResultset(){};

        ///
        virtual const ResultTabletype& GetRecords(void) const;

        ///
        virtual const ResultTabletype& GetRecords(unsigned short offset1, 
                      unsigned short offset2) const;

        ///
        virtual const ResultRecordtype& operator[](unsigned short offset) const;

        ///
        virtual const ResultRecordtype& GetRecord(unsigned short offset) const;

        ///
        virtual const FieldListtype& GetFields(void) const;

        ///
        virtual const unsigned int GetRecordCount(void) const;

        ///
        virtual const string& GetSearchFilter(void) const;

        /// LDAP specific result
        LDAPMessage* myLDAPresult;

        /// LDAP specific handle
        LDAP* myLDAPhandle;

        /// Store the search filter in case the resultset object is
        /// used as input to DBUpdate() or DBDelete()
        const string mySearchFilter;

    public:

        ///
        friend class LDAPConnection;
};

#endif
