#ifndef MYSQLFILTERPARSER_HXX
#define MYSQLFILTERPARSER_HXX

#include <vector>
#include <stack>
#include <string>
#include <strstream>
#include "Filterscanner.hxx"
 
/// MYSQLFilterparser class- 
class MYSQLFilterparser
{
    private:
        ///
        Scanner myScanner;

        ///
        Token* myTokenP;

        ///
        TokenCode myTokencode;

        ///
        string myTokenstring;
        
        ///
        char mySQLclause[256];

        ///
        ostrstream mySQLclausestrm;

        ///
        stack<string, vector<string> > myParsestack;

        ///
        void Parse(void);

        ///
        void ParseFilter(void);

        ///
        void ParseFilterComposition(void);

        ///
        void ParseFilterList(void);

        ///
        void ParseItem(void);

        ///
        void ParseValue(void);

        ///
        void ParseStarValue(void);

        ///
        void GetToken(void);
        
    public:
        ///
        MYSQLFilterparser(const string& filterbuffer);
 
        ///
        virtual ~MYSQLFilterparser(void)
        {}

        ///
        virtual const char* GetParsedresult(void);
};
 
#endif
