#ifndef MYSQLRESULTSET_HXX
#define MYSQLRESULTSET_HXX

#if defined(__svr4__) || defined(__SUNPRO_CC)
    #include "/usr/local/include/mysqlcppapi/mysqlcppapi.h"
#else
    #include <sqlplus.hh>
#endif

#include <string>
#include <vector>
#include "DBResultset.hxx"

///
class MYSQLResultset : public DBResultset
{
    private:
        ///
        MYSQLResultset(const MysqlRes& result, const string& searchfilter);
        ///
        virtual ~MYSQLResultset(){};

        ///
        virtual const ResultTabletype& GetRecords(void) const;
        ///
        virtual const ResultTabletype& GetRecords(unsigned short offset1, 
                      unsigned short offset2) const;
        ///
        virtual const ResultRecordtype& operator[](unsigned short offset) const;
        ///
        virtual const ResultRecordtype& GetRecord(unsigned short offset) const;
        ///
        virtual const FieldListtype& GetFields(void) const;
        ///
        virtual const unsigned int GetRecordCount(void) const;

        ///
        virtual const string& GetSearchFilter(void) const;

        /// MySQL++ Result 
        MysqlRes myMySQLresult;

        /// Store the search filter in case the resultset object is
        /// used as input to DBUpdate() or DBDelete()
        const string mySearchFilter;

        /// STL vector of strings representing fieldlist
        FieldListtype myFieldList;

        /// Number of records in resultset
        int myRecordCount;

    public:
        ///
        friend class MYSQLConnection;
};

#endif
