#include "DBConnection.hxx"
#include "VBadDataException.hxx"

class DifferenceSet;


class ParsedDef {

public:
    
    ParsedDef() {}
    ~ParsedDef() {}

    // accessors
    string getDomain() const { return myDomain; }
    FieldListtype getFieldList() const { return myFieldList; }
    FieldListDatatype getFieldTypes() const { return myFieldTypes; }
    string getPrimaryKey() const { return myPrimaryKey; } 
    
    // setters
    void addField(const string newField) throw (VBadDataException &); 
    void addFieldType(const Datatype newType) throw (VBadDataException &);
    void setPrimaryKey(const string newKey) { myPrimaryKey = newKey; }
    void setDomain(const string newDomain) { myDomain = newDomain; }

    const DifferenceSet compareOld (const ParsedDef &oldDef);
    
protected:

    FieldListtype myFieldList;
    FieldListDatatype myFieldTypes;
    string myPrimaryKey;
    string myDomain;

};


class DifferenceSet {

public:

    DifferenceSet() { myChangedPrimary = false; }
    ~DifferenceSet() {}

    FieldListtype getNewFields() const { return myNewFields; }
    FieldListtype getDelFields() const { return myDelFields; }
    bool changedPrimary() const { return myChangedPrimary; }

    void addNewField(const string newField) {
        myNewFields.push_back(newField); }
    void addDelField(const string delField) {
        myDelFields.push_back(delField); }
    void setChangedPrimary() { myChangedPrimary = true; }
    
protected:

    bool myChangedPrimary;
    FieldListtype myNewFields, myDelFields;

};

