package org.vovida.prov.account;

import org.apache.log4j.Category;

import org.vovida.prov.navigation.NavBarClient;
import org.vovida.prov.navigation.TopLevel;
import org.vovida.prov.table.AdministratorPanel;
import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.logging.Util;
import org.vovida.prov.psLib.ProvisioningInterface;

import javax.swing.JFrame;
import java.awt.BorderLayout;


/**
 * The main panel for Account provisioning.
 */
public class AccountClient extends NavBarClient
{
	AdministratorPanel panel;


  private static Category logCategory = Category.getInstance(AccountClient.class.getName());

  private String adminDomain = "adminAccounts";
  private String adminAcct = "";
  private String childCategory = "endpoints";

  public AccountClient(String name, TopLevel parent)
  {
    super(name, parent);
  }

  public void showSelf()
  {

    try
    {
      ProvisioningInterface pInterface = org.vovida.prov.psLib.SocketProvisioningInterface.getInstance();

      ProvisioningServerWrapper wrapper = new ProvisioningServerWrapper(pInterface);

      if (panel == null)
      {
	      panel = new AdministratorPanel(adminAcct, adminDomain, childCategory,
	        wrapper, (java.awt.Window)this.getTopLevelAncestor());
	      add(panel);
	      panel.setVisible(true);
	      panel.init();
      }
      else
      {
//        panel.reload();
      }

/**
      if(panel != null)
      {
        remove(panel);
      }


      add(panel);
      panel.setVisible(true);
      panel.init();
**/
    }
    catch (Exception ex)
    {
       Util.showException("Could not connect to provisioning server", ex);
	   ex.printStackTrace();
    }
  }


}
