package org.vovida.prov.authentication;

/**
 * Specifies defaults for the AuthTopLevel. <p>
 * Defaults include: <br>
 * <ul>
 *   <li> The default login module
 *   <li> The default applcation class to run which contains the main method
 */
public class AuthConstants
{
    public static final String LOGIN_MODULE = "org.vovida.prov.authentication.PServerLoginModule";
    public static final String MAIN_CLASS = "org.vovida.prov.navigation.TopLevel";
    public static final int NUM_LOGIN_RETRIES = 3;

    /**
     * The callback handler to be used when the authentication package is deployed.
     */
    private static final String PRODUCTION_LOGIN_CALLBACK_HANDLER = "org.vovida.prov.authentication.AuthInput";

    /**
     * The callback handler currently being used.
     */
    public static String LOGIN_CALLBACK_HANDLER = PRODUCTION_LOGIN_CALLBACK_HANDLER;

    public static final String CONF_FILE = "org/vovida/prov/authentication/resources/jaas.conf";
}
