package org.vovida.prov.authentication;

import java.security.Principal;


/**
 * A provisioning server principal. <p>
 * Attached to a subject by the provisioning server login module once the
 * login and commit stagest have suceeded to mark the subject as being
 * successfully authenticated by that module. <p>
 */
public class PSPrincipal implements Principal
{
    private static final String PRINCIPAL_NAME = "PSPrincipal";

    private String accountId;




    public PSPrincipal(String anAccountId)
    {
        accountId = anAccountId;
    }


    /**
     * Return the name of this principal.
     */
    public String getName()
    {
        return PRINCIPAL_NAME;
    }
}
