package org.vovida.prov.authentication;


/**
 * A "wrapper" exception. <p>
 * This class holds another exception and when requested to print its stack
 * trace, it will print the child exception's trace instead.
 */
public class StackTraceException extends RuntimeException 
{
    private Throwable exception;

    StackTraceException(String message)
    {
        super(message);
    }

    StackTraceException(String message, Throwable cause)
    {
        super(message);
        exception = cause;
    }


    public String toString()
    {
        return this.getClass().getName() +  ": " + exception.toString();
    }

    /**
     * Prints the child exception's stack trace instead of its own.
     */
    public void printStackTrace()
    {
        exception.printStackTrace();
    }

}
