package org.vovida.prov.authentication.test;

import org.vovida.prov.psLib.ProvisioningInterface;
import org.vovida.prov.psLib.OperationException;
import org.vovida.prov.psLib.PSDBResult;

import java.io.IOException;
import java.util.Hashtable;




public class AuthTestProvisioningInterface extends ProvisioningInterface 
{
    public static final int RESULT_SUCCESS = 0;
    public static final int RESULT_FAILURE = -1;
	private int nextResult = RESULT_SUCCESS;
	private Exception nextError = null;


    public void setNextResult(int result)
    {
        nextResult = result;
    }


    public void setNextError(IOException error)
    {
        nextError = error;
    }

    public void setNextError(OperationException error)
    {
        nextError = error;
    }

  private boolean operation() throws IOException, OperationException
  {
	if (nextResult == RESULT_SUCCESS)
    {
        return true;
    }
    else
    {
        if (nextError != null)
        {
            if (IOException.class.isInstance(nextError))
            {
                throw (IOException)nextError;
            }
            else if (OperationException.class.isInstance(nextError))
            {
                throw (OperationException)nextError;
            }
            else
            {
                throw new IOException("Failed due to a " + nextError.getClass().getName());
            }
        }
        else
        {
            return false;
        }
    }
  }

  /**
   * Send request to the PServer to authenticate the given account id and
   * password.
   * @param accountId the user name
   * @param password the password for that account
   * @returns true if the authentication succeeded
   */
  public boolean login(String accountId, String password) throws
    IOException, OperationException
  {
    return operation();
  }

  public boolean logout() throws IOException, OperationException
  {
    return operation();
  }

  /**
   * Close the single connection to the data source or server.
   * @throws IOException if the close operation fails
   */
  public void close() throws IOException
  {
    //nothig to do
  }

  /**
   * Send a request to PServer to retrieve all the matching records
   * @param domain the domain to act upon
   * @param filter identifies which records within the supplied domain to act
   * upon.  It is a string of boolean logic (uid=100 & name!='John')
   * @param fieldList used to identify which fields to return for each record
   */
  public PSDBResult getRecordsInDomain(String domain, String filter,
          String[] fieldList) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Get the field names within a domain (corresponding to the column names
   * of, say, a SQL record).
   */
  public String[] getFieldsInDomain(String domain)
    throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Get an XML data description. This describes both a table in the database
   * and a GUI for entering data into that table.
   * @return an XML string describing the requested data.
   */
  public String getXMLFile(String category,
          String filename) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Get a text file "as is" from the www directory.
   */
  public String getRawFile(String filename)
    throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Get the list of all XML data descriptions of a particular category.
   */
  public String[] getListXMLDescriptions(String category)
    throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Given a list of fields within a domain, for each matching field,
   * replace its value with that in the fieldValuePairs.
   * @param domain the domain to act upon
   * @param filter identifies which records within the supplied domain to act
   * upon.  It is a string of boolean logic (uid=1000 & name!='John')
   * @param fieldValuePairs a list of key (eg uid) values (eg 1000)
   */
  public boolean setRecordsInDomain(String domain, String filter,
          Hashtable fieldValuePairs) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Add a new record to a domain.
   * @param domain the domain to act upon
   * @param fieldValuePairs a list of key (eg uid) values (eg 1000)
   */
  public boolean addRecordInDomain(String domain,
          Hashtable fieldValueList) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Remove all records within a domain that match the filter
   * @param domain the domain to act upon
   * @param filter identifies which records within the supplied domain to act
   * upon.   It is a string of boolean logic (uid=100 & name!='John')
   */
  public boolean deleteRecordsInDomain(String domain,
          String filter) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Instruct PServer that the client is interested in monitoring and
   * data change wihtin a domain.  ProvisionigInterface listens for update
   * notification and updates the client by invoking the call back function.
   * <B>NOT IMPLEMENTED</B>
   */
  public boolean registerDomainForUpdate(String domain,
          Object huh) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Similar to registerDomainForUpdate, except the client is interested in
   * monitoring a specific filed within a domain. <B>NOT IMPLEMENTED</B>
   */
  public boolean registerRecordForUpdate(String domain,
          Object huh) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }


  /**
   * Similar to getRecordsInDomain(), except it caches a snapshot of the data
   * locally for the client and automatically monitors and updates the data.
   * The first invocation of this fucntion sends a request to PServer to look
   * up the value(s) associated with the field.  Subsequent calls to this
   * function will result in accessing the resultatnt data locally instead
   * of doing a "true" get via PServer.
   */
  public PSDBResult getCurrentRecordsInDomain(String domain,
          String filter, 
          String[] fieldList) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Open a query session with Provisioning Server which returns a unique
   * indentifier that to which subsequent request can refer.
   * @param timeout how long in milliseconds the server should leave this
   * session open.  After the time has elapsed the server automatically
   * invalidates the session.
   */
  public String sessionOpen(long timeout)
    throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Terminate a query session.
   * @param token the query session indentifier.
   */
  public boolean sessionClose(String token)
    throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Query PServer to lookup all records satisfying the supplied constraints
   * within a domain.  PServer returns the number of matching records.
   * @param token the query session indentifier
   * @param filter identifies which records within the supplied domain to act
   * upon.   It is a string of boolean logic (uid=100 & name!='John')
   * @param fieldList used to identify which fields to return for each record
   * @param sortType one of SORT_TYPE_ASC | SORT_TYPE_DESC
   * @param sortField the field to on which to sort.
   */
  public int sessionSearchDB(String token, String domain,
          String filter, String[] fieldList, String sortType, 
          String sortField) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Query PServer to retrieve a range of records based on the result of
   * the previous sessionSearchDB()
   * @param token the query session indentifier
   * @param start the start number of the range to retrieve.  Inclusive.
   * @param end the end number of the range to retrieve.  Inclusive.
   */
  public PSDBResult sessionGetDBResult(String token, int start, 
          int end, String[] fieldList) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }


  /**
   * Query PServer to sort the result from a previous call to sessionSearchDB()
   * @param token the query session indentifier
   * @param sortType one of SORT_TYPE_ASC | SORT_TYPE_DESC
   * @param sortField the field to on which to sort.
   */
  public boolean sessionSortDBResult(String token, String sortType,
          String sortField) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Instruct PServer to update all the records from a previous call to
   * sessionSearchDB() with the supplied fieldValuePairs
   * @param token the query session indentifier
   * @param fieldValuePairs a list of key (eg uid) values (eg 1000)
   */
  public boolean sessionSetDBResult(String token,
          Hashtable fieldValuePairs) throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }

  /**
   * Remove all the records found by a previous call to sessionSearchDB()
   * @param token the query session indentifier
   */
  public boolean sessionDeleteAll(String token)
    throws IOException, OperationException
  {
    throw new IllegalStateException("Not implemented");
  }
}
