package org.vovida.prov.authentication.test;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;

import java.io.IOException;

import java.util.List;
import java.util.Arrays;

import org.vovida.prov.authentication.AuthTopLevel;



public class LoginSuceeded extends PSTest 
{
    private static int result = FAILURE;
    private static String [] appArgs = new String [] {"foo", "-bar", "bla", "rats"};

	protected int startTest() throws Throwable
    {
        String [] loginArgs = new String [] {AuthTopLevel.OPT_MAIN_CLASS,
            this.getClass().getName(),
            AuthTopLevel.OPT_LOGIN_CALLBACK_HANDLER,
            this.getClass().getName()};

        String [] allArgs = new String [appArgs.length + loginArgs.length];
        int i;
        for (i=0; i<loginArgs.length; i++)
        {
            allArgs[i] = loginArgs[i];
        }
        for (int j=0; j<appArgs.length; j++)
        {
            allArgs[i+j] = appArgs[j];
        }

        AuthTopLevel.main(allArgs);
        return result;
    }

    public String getTestName()
    {
        return "Login succeeded";
    }

    public String getTestDescription()
    {
        return "Verify whether the application main class is started properly assuming that the login succeeded.\nAlso verify that the arguments that are supplied on the command line make it to the application class as expected.";
    }

    public void handle(Callback[] callbacks) throws IOException,
        UnsupportedCallbackException
    {
        for (int i=0; i<callbacks.length; i++)
        {
            if (NameCallback.class.isInstance(callbacks[i]))
            {
                 NameCallback name = (NameCallback)callbacks[i];
                 name.setName("validAcctId");
            }
            else if (PasswordCallback.class.isInstance(callbacks[i]))
            {
                 PasswordCallback password = (PasswordCallback)callbacks[i];
                 password.setPassword("correctPassword".toCharArray());
            }
            else
            {
                //just quietly ignore any unknown callbacks
            }
        }
    }

    public static void main(String [] args)
    {
        if (args.length != appArgs.length)
        {
            result = FAILURE;
            lastMessage = "The number of arguments passed to the main method of the application ("
                + args.length + ") was not equal to the expected number ("
                + appArgs.length + ").";
            return;
        }

        for (int i=0; i<args.length; i++)
        {
            if (!args[i].equals(appArgs[i]))
            {
                result = FAILURE;
                String expected = "";
                for (int j=0; j<appArgs.length; j++)
                {
                    expected += appArgs[j] + " ";
                }
                String got = "";
                for (int j=0; j<args.length; j++)
                {
                    got += args[j] + " ";
                }
                lastMessage = "The argumens passed to the main method of the application are not the same as the expected argumetns."
                    + " Expected: " + expected + " but got: " + got;
                return;
            }
        }
        lastMessage = "Main application class executed successfully.";
        result = SUCCESS;
    }
}
