package org.vovida.prov.authentication.test;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;

import org.vovida.prov.authentication.AuthTopLevel;
import org.vovida.prov.authentication.LoginInitFailedException;

import java.io.IOException;



public class NoArguments extends PSTest
{
	protected int startTest() throws Throwable
    {
        AuthTopLevel.main(new String [] {AuthTopLevel.OPT_LOGIN_CALLBACK_HANDLER,
            this.getClass().getName()});
        lastMessage = "AuthTopLevel did not throw an exception.";
        return SUCCESS;
    }

    public String getTestName()
    {
        return "No arguments";
    }

    public String getTestDescription()
    {
        return "Try to run without supplying any arguments to the main method of the AuthTopLevel";
    }

    public void handle(Callback[] callbacks) throws IOException,
        UnsupportedCallbackException
    {
        for (int i=0; i<callbacks.length; i++)
        {
            if (NameCallback.class.isInstance(callbacks[i]))
            {
                 NameCallback name = (NameCallback)callbacks[i];
                 name.setName("acctId");
            }
            else if (PasswordCallback.class.isInstance(callbacks[i]))
            {
                 PasswordCallback password = (PasswordCallback)callbacks[i];
                 password.setPassword("passwd".toCharArray());
            }
            else
            {
                //just quietly ignore any unknown callbacks
            }
        }
    }
}
