package org.vovida.prov.authentication.test;

import org.vovida.prov.util.RuntimeInfo;

import java.util.Vector;

import org.apache.log4j.Category;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.PatternLayout;







public class Tester
{
    public static void main (String [] arg)
    {
        //log to the console
		Category.getRoot().addAppender(new ConsoleAppender(new PatternLayout("[%t] %-6p %-4L %c{3} - %m%n")));

        Tester tester = new Tester();

        Vector testsv = new Vector();
        testsv.addElement(new NoArguments());
        testsv.addElement(new PrintHelp());
        testsv.addElement(new LoginSuceeded());
        testsv.addElement(new UserCancelsLogin());
//        testsv.addElement(new ShowGuiPasswdInput());
        testsv.addElement(new LoginFailed());

        Test [] tests = new Test[testsv.size()];
        testsv.copyInto(tests);

        tester.runTests(tests);
        System.exit(0);
    }


    private void runTests (Test [] tests)
    {
        for (int i=0; i<tests.length; i++)
        {
            Throwable throwable = null;
            System.out.println("============================================= Test number:" + (i+1) + " =============================================");
            printTestInfo(tests[i]);

            int result = Test.FAILURE;
            System.out.println("                       -------------");
            try
            {
                result = tests[i].run();
            }
            catch (Throwable th)
            {
                throwable = th;
            }

            System.out.println("                       -------------");
            System.out.println("MESSAGE:     " + tests[i].getMessage());
            if (result != Test.SUCCESS)
            {
                if (throwable != null)
                {
                    System.out.println("EXCEPTION:");
                    throwable.printStackTrace();
                    System.out.println();
                }
                System.out.println("----------------------------FAILURE-------------------------");
                System.exit(-1);
            }
            else
            {
                System.out.println("----------------------------SUCCESS---------------------------");
            }
        }
    }

    private void printTestInfo(Test test)
    {
        System.out.println("NAME:        " + test.getTestName());
        System.out.println("DESCRIPTION: " + test.getTestDescription());
    }
}
