package org.vovida.prov.authentication.test;

import org.vovida.prov.authentication.LoginCancelledException;
import org.vovida.prov.authentication.AuthTopLevel;
import org.vovida.prov.authentication.LoginInitFailedException;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.UnsupportedCallbackException;

import java.io.IOException;



public class UserCancelsLogin extends PSTest 
{
    private static int result = FAILURE;

    public void handle(Callback[] callbacks) throws IOException,
        UnsupportedCallbackException
    {
        throw new LoginCancelledException();
    }

	protected int startTest() throws Throwable
    {
        try
        {
	        AuthTopLevel.main(new String [] {AuthTopLevel.OPT_MAIN_CLASS,
	            this.getClass().getName(),
	            AuthTopLevel.OPT_LOGIN_CALLBACK_HANDLER,
	            this.getClass().getName()});
        }
        catch (LoginInitFailedException ex)
        {
            lastMessage = "LoginInitFailedException was thrown as expected";
            result = SUCCESS;
        }
        return result;
    }

    public String getTestName()
    {
        return "User cancels login";
    }

    public String getTestDescription()
    {
        return "Make sure the application does not get executed if the user presses the cancel button when prompted to enter account id and password";
    }

    public static void main(String [] args)
    {
        lastMessage = "Error: the main application class was executed";
        result = FAILURE;
    }
}
