/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF ,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
package org.vovida.prov.dynamicGui;

/**
 * This class contains all of the Elements and Attributes
 * used in type.dtd.
 *
 * @author Barbara Samson
 */
public interface DTDConstants
{

  // Elements in type.dtd

  public final static String DATADEFN = "DataDefn";
  public final static String CATEGORY = "Category";
  public final static String DBENTRY = "DBEntry";
  public final static String BORDER = "Border";
  public final static String LABEL = "Label";
  public final static String TOOLTIP = "Tooltip";
  public final static String ALERT = "Alert";
  public final static String DEFAULT = "Default";
  public final static String REQUIRED = "Required";
  public final static String HIDDEN = "Hidden";
  public final static String MININCLUSIVE = "MinInclusive";
  public final static String MAXINCLUSIVE = "MaxInclusive";
  public final static String CONTENT = "Content";
  public final static String STRINGTYPE = "StringType";
  public final static String INTEGERTYPE = "IntegerType";
  public final static String BOOLEANTYPE = "BooleanType";
  public final static String HOSTTYPE = "HostType";
  public final static String HOSTPORTTYPE = "HostPortType";
  public final static String DECIMALTYPE = "DecimalType";
  public final static String DATETYPE = "DateType";
  public final static String TIMETYPE = "TimeType";
  public final static String TABLETYPE = "TableType";
  public final static String WIDGET = "Widget";
  public final static String TEXTFIELD = "TextField";
  public final static String COMBOBOX = "ComboBox";
  public final static String RADIOBUTTONS = "RadioButtons";
  public final static String CHECKBOX = "CheckBox";
  public final static String TABLE = "Table";
  public final static String HOSTPORTFIELD = "HostPortField";
  public final static String PSERVER = "PServer";
  public final static String GETRECORDSINDOMAIN = "GetRecordsInDomain";
  public final static String GETDOMAINS = "GetDomains";
  public final static String ENUMERATION = "Enumeration";
  public final static String ENTRY = "Entry";
  public final static String REFERENCE = "Reference";
  public final static String COLUMN = "Column";
  public final static String CONDITION = "Condition";
  public final static String ACTION = "Action";
  public final static String ENABLE = "Enable";
  public final static String DISABLE = "Disable";
  public final static String PAGED_CONTAINER = "PagedContainer";
  public final static String PAGE = "Page";

  // Attributes in type.dtd

  public final static String NAME = "name";
  public final static String KEY = "key";
  public final static String ENABLED = "enabled";
  public final static String USERINPUTOK = "userInputOK";
  public final static String DOMAIN = "domain";
  public final static String FIELD = "field";
  public final static String FILTER = "filter";
  public final static String CATEGORY_ATTR = "category";
  public final static String VALUE = "value";
  public final static String TARGET = "target";


  // Attribute values in type.dtd

  public final static String TRUE = "true";
  public final static String FALSE = "false";

}

