package org.vovida.prov.group;

import org.vovida.prov.group.GroupNode;
import org.vovida.prov.util.assert.*;

import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.JTree;
import java.awt.Component;



public class GroupTreeRenderer extends DefaultTreeCellRenderer
{
    public Component getTreeCellRendererComponent(JTree tree, Object value,
        boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus)
    {
		super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);

        Assert.assert("value is a tree node", DefaultMutableTreeNode.class.isInstance(value));

        DefaultMutableTreeNode node = (DefaultMutableTreeNode)value;

		Object userObject = node.getUserObject();
        if (GroupNode.class.isInstance(userObject))
        {
            if (expanded)
            {
	            this.setIcon(this.openIcon);
            }
            else
            {
	            this.setIcon(this.closedIcon);
            }
        }

        return this;
    }
}
