package org.vovida.prov.group.action;

import javax.swing.AbstractAction;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.DefaultMutableTreeNode;

import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.assert.*;


public abstract class ActionGroup extends AbstractAction
{
    protected ProvisioningServerWrapper server;
    protected String accountIdentifier;
    protected String domain;
    protected JTree tree;
    protected TreePath clickedPath;


	public ActionGroup(String actionName, String accountId, String aDomain,
        ProvisioningServerWrapper psInt, JTree aTree)
    {
        super(actionName);
        accountIdentifier = accountId;
        domain = aDomain;
        server = psInt;
        tree = aTree;
        Assert.assert("tree model is default",
            DefaultTreeModel.class.isInstance(tree.getModel()));
    }

    public void setClickedPath(TreePath path)
    {
		clickedPath = path;
    }

}
