/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF ,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
package org.vovida.prov.navigation;

/**
 * This class contains the constants used for initial configuration.
 * It also contains the categories that can be requested from PServer.
 * 
 * @author Barbara Samson
 */
public interface ConfigConstants
{

  // specifies the list of all hosts for drop-down list
  public static final String HOSTS_XML = "Hosts.xml";

  // specifies the choices on the top level navigation bar
  public static final String NAVBAR_XML = "NavBar.xml";

  // specifies the dimensions and name of custom gif logo.
  public static final String NAVBARLOGO_XML = "NavBarLogo.xml";

  // Elements in Hosts.xml
  public static final String HOSTS = "hosts";
  public static final String HOST = "host";

  // Elements in NavBar.xml
  public static final String NAVBARCLIENTS = "navBarClients";
  public static final String CLIENT = "client";

  // Attributes in NavBar.xml
  public static final String NAME = "name";
  public static final String CLASS = "class";

  // Elements in NavBarLogo.xml
  public static final String NAVBARLOGO = "NavBarLogo";

  // Attributes in NavBarLogo.xml
  // name has already been done
  public static final String HEIGHT = "height";
  public static final String WIDTH = "width";

  // Categories to request from PServer
  public final static String SERVERS = "servers";
  public final static String ENDPOINTS = "endpoints";
  public final static String FEATURE = "feature";
  public final static String CONFIG = "config";

}

