/* Generated by Together */

package org.vovida.prov.navigation.test;

import java.util.Properties;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.net.URL;

import org.vovida.prov.navigation.TopLevel;
import org.vovida.prov.psLib.SocketProvisioningInterface;
import org.vovida.prov.util.logging.LogClient;
import org.vovida.prov.psLib.ProvisioningInterface;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.Category;

public class TestTopLevel
{
  static Category logCategory
    = Category.getInstance(TestTopLevel.class.getName());

  public static void main(String[] args)
  {
    if (args.length != 2)
    {
      usage();
      return;
    }
    // Until we get config file, log everything.
    BasicConfigurator.configure();
    logCategory.info("Logging configured from BasicConfigurator");

    try
    {
      SocketProvisioningInterface.initialize(args[0],
        Integer.parseInt(args[1]));
    }
    catch (NumberFormatException e)
    {
      usage();
      return;
    }
    ProvisioningInterface ps = ProvisioningInterface.getInstance();

    String logConfig = null;

    try
    {
      logConfig = ps.getRawFile("logConfig");
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }

    // If logConfig cannot be read, we get an error message instead.
    if ( (logConfig != null) && (!logConfig.startsWith("<error>")) )
    {
      Properties props = new Properties();
      try
      {
        props.load(new ByteArrayInputStream(logConfig.getBytes()));
      }
      catch (IOException e)
      {
        e.printStackTrace();
      }
      new PropertyConfigurator().doConfigure(props,
        Category.defaultHierarchy);
      logCategory.warn("Logging configured from file");
    }

    TopLevel topLevel = new TopLevel();
    topLevel.createClients();
    topLevel.pack();
    topLevel.setVisible(true);

  }

  private static void usage()
  {
	System.out.println("Usage: TestTopLevel <host> <port>");
  }

}


