package org.vovida.prov.psLib.test;

import java.net.*;
import java.io.*;

class EchoServer
{
  public static void main(String[] args) throws IOException
  {
    ServerSocket serverSocket = null;
    try
    {
      serverSocket = new ServerSocket(80);
    }
    catch (IOException e)
    {
      System.err.println("Could not listen on port: 4444.");
      System.exit(1);
    }
    Socket clientSocket = null;
    System.out.println("Connected.");

    while (true)
    {
      try
      {
        clientSocket = serverSocket.accept();
        System.out.println("Local Port: " + clientSocket.getLocalPort());
        System.out.println("Remote Port: " + clientSocket.getPort());
      }
      catch (IOException e)
      {
        System.err.println("Accept failed.");
        System.exit(1);
      }
      System.out.println("Connected to client");
      PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
      BufferedReader in = new BufferedReader(
          new InputStreamReader(clientSocket.getInputStream()));
      String inputLine, outputLine;
      while ((inputLine = in.readLine()) != null)
      {
        System.out.println(inputLine);
        outputLine = inputLine;
        out.println(outputLine);
        if (outputLine.equals("Bye."))
          break;
      }
      System.out.println("Closing Connection...\n\n");

      out.close();
      in.close();
      clientSocket.close();
    }
  }
}
