package org.vovida.prov.table;

import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.table.task.TaskLoadAccountKeys;

import javax.swing.JTable;
import javax.swing.JOptionPane;

import org.apache.log4j.Category;




public class AccountSortRequestListener extends SortRequestListener
{
    private static Category logCategory = Category.getInstance(AccountSortRequestListener.class.getName());


    /**
     * The panel which displays the table to be storted. <p>
     * This is used to determine which rows are visible.
     */
    private TableScreen screen;

    /**
     * Used to communicate with the server and initiate sorts of the data.
     */
    private ProvisioningServerWrapper server;


    public AccountSortRequestListener(JTable aTable, ProvisioningServerWrapper psInt,
        TableScreen aScreen, int sortColumn)
    {
		super(aTable);
        server = psInt;
        screen = aScreen;
        currentSortColumn = sortColumn;
    }

    protected void sort(int column, String order)
    {
        //call the server to perform the sort operation
            //need
            // - account type
            // - name of field to sort on
            // - sort order
        TableModel model = (TableModel)table.getModel();

        if (!model.getColumns()[currentSortColumn].isDomainColumn())
        {
       		JOptionPane.showMessageDialog(screen, "Cannot sort on this column.\nIt doest not come from the domain.");
            return;
        }

        try
        {
	        server.sortOn(sortOrder,((NamedTableColumn)table.getColumnModel().getColumn(currentSortColumn)).getColumnId());
        }
        catch (Exception ex)
        {
           logCategory.error("Could not sort data", ex);
           org.vovida.prov.util.logging.Util.showException("Could not sort data",ex);
        }

        //indicate that the rowModel is now invalid
        model.invalidateRowModel();

        //cause the table to be updated
            // - get indices the currently visible rows
            // - get from provisioning server the identifiers of the accounts at
            //   these indices
            // - cause the rowModel to be remapped for these rows
       int firstRow = screen.getFirstVisibleRow();
       int lastRow = screen.getLastVisibleRow();

       screen.loadScreenOfData();
    }

}
