package org.vovida.prov.table;

import javax.swing.JScrollBar;

/**
 * In order to attach mouse listeners to the increment and decrement buttons in
 * a scroll bar, it is necessary to use a custom ui. In order to attach this ui
 * to the scrollbar, it is ncessesary to access the protected setUI method. To
 * do this, JScrollBar is subclassed.
 * This is of interest when tryin to detect mouse clicks on the increment and
 * decrement buttons of a scroll bar to implement paging in the table of
 * accounts.
 */
public class CustomScrollBar extends JScrollBar
{
    public CustomScrollBar (CustomScrollBarUI ui)
    {
        super();
        ui.installUI(this);
        setUI(ui);
    }
}
