package org.vovida.prov.table;

import org.vovida.prov.table.event.*;
//import org.vovida.common.serverInterface.ProvisioningServerInterface;
import org.vovida.prov.util.assert.*;
import org.vovida.prov.util.*;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import javax.swing.JScrollBar;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;



import java.awt.BorderLayout;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Dimension;
import java.awt.Point;

import java.util.Vector;

import org.apache.log4j.Category;

class SortInfoKeeper extends MouseAdapter
{
    SortRequestListener listener;
    JTable table;
    TableModel model;

    public SortInfoKeeper (SortRequestListener aListener, JTable aTable, TableModel aModel)
    {
        listener = aListener;
        table = aTable;
        model = aModel;
		setSortInfo();
    }

    private Loop loop = new Loop(RowModel.LOOP_SIZE);

    private void setSortInfo()
    {
        SortInfo info = new SortInfo();
        info.sortOrder = listener.getSortOrder();
        info.sortColumn = listener.getCurrentSortColumn();
        loop.add(info);
    }

    public void mouseClicked(MouseEvent event)
    {
        setSortInfo();
    }

    public void back()
    {
        model.backRowToIdMap();
        SortInfo info = (SortInfo)loop.back();
        restoreSortInfo(info);
    }

    public void forward()
    {
        model.forwardRowToIdMap();
        SortInfo info = (SortInfo)loop.forward();
        restoreSortInfo(info);
    }

    private void restoreSortInfo(SortInfo info)
    {
        if (info != null)
        {
            listener.setCurrentSortColumn(info.sortColumn);
            listener.setSortOrder(info.sortOrder);
        }
        model.fireTableDataChanged();
        table.getTableHeader().repaint();
    }

	public SortInfo getSortInfo()
    {
        return (SortInfo)loop.getCurrent();
    }
}


