
package org.vovida.prov.table.action;

import org.vovida.prov.userEdit.UserEditorPanel;
import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.FieldNames;
import org.vovida.prov.table.TableScreen;

import java.awt.Window;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import org.apache.log4j.Category;



public class ActionAdd extends ActionChangeUsers 
{
    private static Category logCategory = Category.getInstance(ActionAdd.class.getName());

    public ActionAdd(ProvisioningServerWrapper wrapper, TableScreen screen,
        String actionName, String anAdminName, String anAdminDomain,
        String aUserDomain, Window aParent)
    {
        super(wrapper,screen,actionName,anAdminName,anAdminDomain,aUserDomain,aParent);
    }

    protected boolean prepare()
    {
        userEditor.setTitle("Create new account");
        return true;
    }

  	protected void doWork()
    {
		if (panel.getLastButton() == panel.BUTTON_OK)
        {
	        int row = tableScreen.getTable().getRowCount();

           //get the data for the tab that edits the values which are displayed
           //in the table.
           Hashtable data = panel.getData(userDomain);
           if (data != null)
           {
               tableScreen.getTableModel().ensureDataCapacity(row+1);
               String acctId = (String)data.get(FieldNames.userIdConlumnName);
               tableScreen.getTableModel().addAccount(acctId,row);

	           Enumeration keys = data.keys();
               while(keys.hasMoreElements())
	           {
	               String key = (String)keys.nextElement();
		           String value = (String)data.get(key);
			       tableScreen.getTableModel().setValueAt(row,key,value);
	           }
           }
           else
           {
               logCategory.warn("Null data for " + userDomain + "tab.");
           }

	       //check the selected features
	       String [] features = panel.getSelectedFeatures();
	           for (int j=0; j<features.length; j++)
	           {
	        	   tableScreen.getTableModel().setValueAt(row,features[j],"true");
	           }

		   tableScreen.getTableModel().fireTableDataChanged();
        }
    }
}

