package org.vovida.prov.table.action;

import java.awt.Frame;
import java.awt.event.ActionEvent;

import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.assert.Assert;
import org.vovida.prov.util.logging.Util;
import org.vovida.prov.table.TableScreen;

import org.apache.log4j.Category;



public class ActionClearSearch extends ActionTable
{
    private static Category logCategory = Category.getInstance(ActionClearSearch.class.getName());

    public ActionClearSearch(ProvisioningServerWrapper wrapper,
        TableScreen screen, String actionName, Frame parent)
    {
        super(actionName, wrapper, screen, parent);
    }

     public void actionPerformed(ActionEvent event)
     {
        tableScreen.getTableModel().invalidateRowModel();
        try
        {
			//closing the session clears the provisioning server's cache
	        server.closeSession();

            //find out again how many total accounts there are
            int count = server.getAccountCount(tableScreen.getTableModel().getDomain(), /*child domain*/
                tableScreen.getTableModel().getAccountId(), /*parent account*/
                tableScreen.getSortInfo().sortOrder);

            //set size of the scroll bars
            tableScreen.getTableModel().ensureDataCapacity(count);

			//reload the account keys and if necessary, the account data
	        reloadData();
        }
        catch (Exception ex)
        {
			String message = "Could not colse session on provisioning server";
            logCategory.error(message,ex);
            Util.showException(message,ex);
        }
     }

}
