package org.vovida.prov.table.action;

import java.awt.Window;
import java.awt.event.ActionEvent;

import javax.swing.JDialog;

import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;

import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.FieldNames;
import org.vovida.prov.util.logging.Util;
import org.vovida.prov.table.TableScreen;
import org.vovida.prov.table.NamedTableColumn;
import org.vovida.prov.userEdit.UserEditorPanel;
import org.vovida.prov.userEdit.UIRepository;

import org.apache.log4j.Category;



public class ActionEdit extends ActionChangeUsers 
{
    private static Category logCategory = Category.getInstance(ActionEdit.class.getName());

    protected int [] selectedRows;

    public ActionEdit(ProvisioningServerWrapper wrapper, TableScreen screen,
        String actionName, String anAdminName, String anAdminDomain,
        String aUserDomain, Window aParent)
    {
        super(wrapper,screen,actionName,anAdminName,anAdminDomain,
            aUserDomain,aParent);
    }


    protected boolean prepare()
    {
		if(tableScreen.getTable().getSelectedRowCount() < 1)
        {
			logCategory.debug("No rows selected for edit");
            return false;
        }

        //find the selected rows
        selectedRows = tableScreen.getTable().getSelectedRows();

        //get the account names for the selected rows
        String [] accountNames = new String [selectedRows.length];
        for (int i=0; i<selectedRows.length; i++)
        {
            int row = selectedRows[i];
            String name = (String)tableScreen.getTableModel().getValueAt(row,findNameIndex()); //TO DO:
            accountNames[i] = name;
        }

        String [] selectedFeatures = null;
        if (accountNames.length == 1)
        {
            //get the selected features for this account
			NamedTableColumn [] columns = tableScreen.getTableModel().getColumns();
            Vector features = new Vector();
            for (int i=0; i<columns.length; i++)
            {
            	if (!columns[i].isDomainColumn())
	            {
                    if ("true".equals(tableScreen.getTableModel().getValueAt(selectedRows[0],columns[i].getModelIndex())))
                    {
						String featureId = columns[i].getColumnId();
    					features.addElement(featureId);
                    }
	            }
            }
            selectedFeatures = new String[features.size()];
            features.copyInto(selectedFeatures);
        }

        panel.setAccounts(accountNames,selectedFeatures);

        if (accountNames.length == 1)
        {
            userEditor.setTitle("Edit account - " + accountNames[0]);
        }
        else
        {
            userEditor.setTitle("Edit accounts");
        }

        return true;
    }

	protected void doWork()
    {
		if (panel.getLastButton() == panel.BUTTON_OK)
        {
	       //check the selected features
           for (int i=0; i<selectedRows.length; i++)
	       {
               setChangedFeaturesInTable(selectedRows[i]);
	       }

           //get the data for the tab that edits the values which are displayed
           //in the table.
           Hashtable data = panel.getChangedData(userDomain);
           Enumeration keys = data.keys();
           while(keys.hasMoreElements())
           {
               String key = (String)keys.nextElement();
               if (!key.equals(FieldNames.userIdConlumnName))
               {
	               String value = (String)data.get(key);
	               for (int i=0; i<selectedRows.length; i++)
	               {
		               tableScreen.getTableModel().setValueAt(selectedRows[i],key,value);
	               }
               }
           }
		   tableScreen.getTableModel().fireTableDataChanged();
        } //end if button = OK
    }
}
