package org.vovida.prov.table.action;

import javax.swing.AbstractAction;

import org.vovida.prov.table.TableScreen;
import org.vovida.prov.table.task.TaskLoadAccountKeys;
import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.task.Task;
import org.vovida.prov.util.task.TaskListener;
import org.vovida.prov.util.FieldNames;
import java.awt.Window;




public abstract class ActionTable extends AbstractAction
{
    protected ProvisioningServerWrapper server;
    protected Window parent;
    private int nameIndex = -1;
    protected TableScreen tableScreen;


    public ActionTable(String actionName, ProvisioningServerWrapper wrapper,
        TableScreen screen, Window aParent)
    {
		super(actionName);
        server = wrapper;
        tableScreen = screen;
    }

    protected int findNameIndex()
    {
        //find the column which stores the account names
        if (nameIndex == -1) //not initialized yet
        {
	        for (int i=0; i<tableScreen.getTable().getColumnCount(); i++)
	        {
                if (FieldNames.keyField.equals(tableScreen.getTableModel().getColumns()[i].getColumnId()))
//				if (FieldNames.userIdConlumnName.equals(tableScreen.getTableModel().getColumns()[i].getColumnId()))
	            {
	                nameIndex = i;
                    break;
	            }
	        }
        }

        return nameIndex;
    }

    protected void reloadData()
    {
                //reload the account keys in the new order
                new TaskLoadAccountKeys(0,tableScreen.getLastVisibleRow(),
                    tableScreen.getTableModel().getDomain(),
                    tableScreen.getTableModel().getAccountId(),
                    tableScreen.getTableModel().getColumns()[0].getColumnId(), //assume the first column is the key
                    tableScreen.getSortInfo().sortOrder,
                    server,
                    tableScreen.getTableModel(),
                    new TaskListener()
	                {
	                 	public void taskFinished(Task task, boolean status, Object returnValue)
		                 {
					        //once keys have been loaded, reload the data if necessary
							tableScreen.loadScreenOfData(); //starts a new task to load
		                 }
	                }).start();
    }
}
