package org.vovida.prov.table.event;

import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.MouseAdapter;

/**
 * This class compacts (discards) successive AdjustmentEvents generated by
 * scrolling a scroll bar which occur between MousePressedEvents.
 */
public class AdjustmentEventCompactor extends EventCompactor
                                      implements AdjustmentListener
{
    /**
     * Called when the scollbar is scrolled. <p>
     * Needs to figgure out the first and last visible rows in the table,
     * see if data is loaded for them and if not, initiate a task to load it
     * as well as data for a screen full ahead and behind this one.
     */
    public void adjustmentValueChanged(AdjustmentEvent event)
    {
//		System.out.println("AdjustmentEventCompactor.adjustmentValueChanged");
        eventOccurred(event);
    }
}
