package org.vovida.prov.table.search;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDialog;
import javax.swing.JTextField;
import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.border.EmptyBorder;

import org.vovida.prov.table.TableModel;



public class SearchInputDialog extends JDialog
{
    private JTextField searchField = new JTextField("");
    private JButton ok = new JButton("OK");
    private JButton cancel = new JButton("Cancel");
    private String searchString = null;
    private JTextField searchDomain = new JTextField("");
    private String domainString = null;


    public SearchInputDialog (Frame parent, TableModel toBeSearched)
    {
        super(parent, "Enter search criteria", true);

        JPanel content = new JPanel();
        content.setBorder(new EmptyBorder(3,3,3,3));

        content.setLayout(new BoxLayout(content, BoxLayout.Y_AXIS));

        JPanel temp = new JPanel();
        temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
        temp.add(new JLabel("Enter search domain:"));
        temp.add(Box.createHorizontalGlue());
        content.add(temp);

        temp = new JPanel();
        temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
        temp.add(Box.createHorizontalStrut(30));
		temp.add(searchDomain);
        content.add(temp);

        temp = new JPanel();
        temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
        temp.add(new JLabel("Enter search string:"));
        temp.add(Box.createHorizontalGlue());
        content.add(temp);

        temp = new JPanel();
        temp.setLayout(new BoxLayout(temp,BoxLayout.X_AXIS));
        temp.add(Box.createHorizontalStrut(30));
        searchField.setPreferredSize(new Dimension(250,searchField.getPreferredSize().height));
        temp.add(searchField);
        content.add(temp);

        content.add(Box.createVerticalStrut(3));

        temp = new JPanel();
        temp.setLayout(new BoxLayout(temp,BoxLayout.X_AXIS));
        temp.add(Box.createHorizontalGlue());
        temp.add(ok);
        temp.add(cancel);
        content.add(temp);

        getContentPane().add(content);

		ok.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                searchString = searchField.getText();
                domainString = searchDomain.getText();
                setVisible(false);
            }
        });

        cancel.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                searchString = null;
                domainString = null;
                setVisible(false);
            }
        });

		searchField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                searchString = searchField.getText();
                domainString = searchDomain.getText();
                setVisible(false);
            }
        });

        pack();

	    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	    this.setLocation((d.width - this.getSize().width) / 2,
	                      (d.height - this.getSize().height) / 2);
    }

    public String getSearchString()
    {
        if (searchString != null)
        {
            return searchString.trim();
        }
        return null;
    }

    public void setDefaultSearchDomain(String domain)
    {
        searchDomain.setText(domain);
    }

    public String getSearchDomain()
    {
        if (domainString != null)
        {
            return domainString.trim();
        }
        return null;
    }
}
