package org.vovida.prov.table.test;

import java.awt.BorderLayout;
import org.vovida.prov.util.AppletApp;
import org.vovida.prov.util.ProvisioningServerWrapper;
import org.vovida.prov.util.logging.Util;
import org.vovida.prov.table.AdministratorPanel;
import org.vovida.prov.psLib.ProvisioningInterface;

import javax.swing.JFrame;



public class TestAdminPanel extends AppletApp
{

    public void init()
    {
    }

	public static void main (String [] arg)
    {
		TestAdminPanel test = new TestAdminPanel();
        test.isStandalone = true;

        if (arg.length < 4)
        {
            System.out.println("Not enough arguments ...");
            System.out.println("Usage:");
            System.out.println("  TestAdminPanel host port childCategory adminDomain [adminAcct]");
            System.exit(0);
        }

        String host = test.getParameter("host", arg[0]);
        int port = Integer.parseInt(test.getParameter("port", arg[1]));
        String childCategory = test.getParameter("childCategory",arg[2]);
        String adminDomain = test.getParameter("adminDomain", arg[3]);
        String adminAcct = "";
        if (arg.length > 4)
        {
			adminAcct = test.getParameter("adminAcct", arg[4]);
        }

        try
        {
            org.vovida.prov.psLib.SocketProvisioningInterface.initialize(host,port);
			ProvisioningInterface pInterface =
                org.vovida.prov.psLib.SocketProvisioningInterface.getInstance();

	        ProvisioningServerWrapper wrapper = new ProvisioningServerWrapper(pInterface);

            JFrame frame = createFrame();
	        AdministratorPanel panel = new AdministratorPanel(adminAcct,
                adminDomain, childCategory, wrapper,frame);
	        frame.getContentPane().add(panel,BorderLayout.CENTER);
            frame.pack();
            frame.setTitle("Account Provisioning - " + adminAcct);
            panel.init();
        }
        catch (Exception ex)
        {
            Util.showException("Could not connect to provisioning server", ex);
            if (test.isStandalone)
            {
                System.exit(-1);
            }
        }
    }
}
