/* Generated by Together */

package org.vovida.prov.template.test;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.BorderLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JOptionPane;
import java.net.URL;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.io.File;

import org.vovida.prov.util.logging.LogClient;
import org.vovida.prov.psLib.ProvisioningInterface;
import org.vovida.prov.psLib.SocketProvisioningInterface;
import org.vovida.prov.template.BulkAddController;
import org.vovida.prov.template.XMLTemplateLoader;
import org.vovida.prov.template.TemplateBuilder;
import org.vovida.prov.template.TemplateLoader;
import org.vovida.prov.template.NestedException;
import org.vovida.prov.dynamicGui.TypeBuilder;

public class TemplateTester
{
  public static void main(String[] args) throws Exception
  {
    if (args.length != 2)
    {
      System.out.println("Usage: TemplateTester <host> <port>");
      return;
    }
    try
    {
      SocketProvisioningInterface.initialize(args[0],
        Integer.parseInt(args[1]));
    }
    catch (NumberFormatException e)
    {
      System.out.println("Usage: TemplateTester <host> <port>");
      return;
    }
    LogClient.configureFromFile();
    try
    {
      new TemplateTester().start();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }


  private void start()
    throws NestedException
  {
    ProvisioningInterface ps = ProvisioningInterface.getInstance();

    final JFrame mainFrame = new JFrame("Template Tester");
    JButton tbButton = new JButton("Template Builder");
    JButton addButton = new JButton("Add With Template");

    //ProvisioningInterface.templateTesting = true;
    //load all the xml parent files.
    //File dir = new File(DummyProvisioningInterface.DEFINITION_DIR);

    // Get a list of all description files in the system.

    String endpointFile = "";
      String[] allEndpoints = null;
      try
      {
        allEndpoints = ps.getListXMLDescriptions("endpoints");
      }
      catch (Exception e1)
      {
        JOptionPane.showMessageDialog(new JFrame(), "error in list of XML Descriptions"
        + ": " + e1.getMessage(), e1.getClass().toString(),
        JOptionPane.ERROR_MESSAGE);
        return;
      }
      if (allEndpoints == null)
      {
        return;
      }
      for (int i = 0; i < allEndpoints.length; i++)
      {
        endpointFile = allEndpoints[i];
        String xmlString = null;
        try
        {
          xmlString = ps.getXMLFile("endpoints", endpointFile);
        }
        catch (Exception e2)
        {
          JOptionPane.showMessageDialog(new JFrame(), "error in " + endpointFile
          + ": " + e2.getMessage(), e2.getClass().toString(),
          JOptionPane.ERROR_MESSAGE);
          continue;
        }
    
        // create all ProvisionableTypes in hashtable.
        TypeBuilder.buildType(xmlString);
      }
      final TemplateLoader tl = new XMLTemplateLoader();

    //
    // Action stuff for Template Builder
    //
    tbButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ae) {
        final TemplateBuilder tb = new TemplateBuilder(mainFrame, tl);
        tb.pack();
        tb.setVisible(true);
      }
    });

    //
    // Action stuff for Adding with Templates
    //
    addButton.addActionListener(new BulkAddController(mainFrame, tl));


    //
    // Frame stuff
    //
    mainFrame.getContentPane().add(BorderLayout.WEST, tbButton);
    mainFrame.getContentPane().add(BorderLayout.EAST, addButton);
    mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    mainFrame.pack();
    mainFrame.setVisible(true);
    mainFrame.getGlassPane().setVisible(true);
  }

}
