package org.vovida.prov.util;

import java.util.Vector;
import java.util.StringTokenizer;


public class ParseUtils
{
     /**
      * Convert the given vector of strings into a comma delimited list.<p>
      */
     public static String generateCommaDelimitedString(Vector strings)
     {
     	String stringList = "";
        int numStrings = strings.size();
        for (int i=0; i<numStrings; i++)
        {
            stringList += strings.elementAt(i);
            if (i != numStrings-1)
            {
                stringList += ",";
            }
        }
        return stringList;
     }


     public static String [] parseCommaDelimitedString(String string)
     {
        StringTokenizer tokenizer = new StringTokenizer(string,",");
        int tokenCount = tokenizer.countTokens();
        String [] list = new String[tokenCount];
        for (int i=0; i<tokenCount; i++)
        {
            list[i] = tokenizer.nextToken();
        }
		return list;
     }

     /**
      * If the given array of strings contains the given string, remove it
      * from the list and return it as a comma-delimited list.
      */
     public static String removeStringFromList(String item, String [] list)
     {
        Vector tempList = new Vector();
        for (int i=0; i<list.length; i++)
        {
            tempList.add(list[i]);
        }

        if (tempList.contains(item))
        {
            tempList.remove(item);
        }

        String result = "";
        for (int i=0; i<tempList.size(); i++)
        {
            result += tempList.elementAt(i);
            if (i < tempList.size()-1)
            {
                result += ",";
            }
        }

        return result;
     }

    /**
     * Assume the <code>list</code> is a comma delimited list of strings<p>
     * If the given string exists in the <code>list</code>, remove
     * it and return the remaining strings in a comma delimited list. <p>
     */
    public static String removeStringFromList(String toRemove, String list)
    {
        int index = list.indexOf(toRemove);
        String returnValue = list;
        if (index != -1)
        {
            if (index > 0)
            {
				returnValue = list.substring(0,index);
            }
            else
            {
                returnValue = "";
            }

            returnValue += list.substring(index+toRemove.length(),list.length());
        }
        return returnValue;
    }
}
