package org.vovida.prov.util;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.StringTokenizer;
import java.awt.MediaTracker;


public class RuntimeInfo
{
    /**
     * Return the name of the currently executing thread.
     */
    public static String getThread()
    {
        return Thread.currentThread().getName();
    }

    /**
     * Returns the stack trace for the given throwable object.
     */
    public static String getStackTrace(Throwable throwable)
    {
        ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
        PrintStream printStream = new PrintStream(byteOut);
        throwable.printStackTrace(printStream);
        return byteOut.toString();
    }

    public static String getImageLoadStatusString(int status)
    {
        switch (status)
        {
            case MediaTracker.LOADING:
            {
                return "LOADING";
            }
            case MediaTracker.ABORTED:
            {
                return "ABORTED";
            }
            case MediaTracker.COMPLETE:
            {
                return "COMPLETE";
            }
            case MediaTracker.ERRORED:
            {
                return "ERROR";
            }
        }
        return "UNKNOWN";
    }

    /**
     * Attempts to determine the name of the method from which this method
     * was called. This uses an exception stack trace and will try to get the
     * name of the first method that does not belog to the Logger class.
     */
    public static String getMethod()
    {
        String method = "";
        try
        {
            throw new Exception ("message");
        }
        catch (Exception exception)
        {
            StringTokenizer traceTokenizer =
                    new StringTokenizer(getStackTrace(exception), "\n", false);
            String token = traceTokenizer.nextToken();
            while (token.indexOf("Logger") != -1)
            {
                token = traceTokenizer.nextToken();
            }
            method = token.trim();
        }
        return method;
    }
}
