package org.vovida.prov.util.logging;

import org.vovida.prov.util.RuntimeInfo;

import javax.swing.BoxLayout;
import javax.swing.Box;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JTextArea;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JTextPane;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.Dialog;
import java.awt.Frame;



public class Util
{
    private static JDialog frame;
    private static JLabel message;
    private static JScrollPane scroller;
    private static JTextArea details;
    private static boolean detailsVisible = false;

    private static Throwable throwable;



    private static void initMessageBox()
    {
        frame = new JDialog((Frame)null, "Message", true);
        frame.getContentPane().setLayout(new BorderLayout());

        message = new JLabel();
        JPanel temp = new JPanel();
        temp.setLayout(new BoxLayout(temp,BoxLayout.X_AXIS));
        temp.setBorder(new EmptyBorder(5,5,5,5));
        temp.add(message);
        temp.add(Box.createHorizontalGlue());
        frame.getContentPane().add(temp,BorderLayout.NORTH);

        details = new JTextArea();
        scroller = new JScrollPane(details);
        scroller.setPreferredSize(new Dimension(700,200));

        final JButton showDetails = new JButton("Show details");
        showDetails.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                if (detailsVisible)
                {
                    showDetails.setText("Show details");
                    frame.getContentPane().remove(scroller);
                    detailsVisible = false;
                    frame.pack();
                    frame.repaint();
                    frame.validate();
                }
                else
                {
                    showDetails.setText("Hide details");
                    details.setText(RuntimeInfo.getStackTrace(throwable));
                    frame.getContentPane().add(scroller,BorderLayout.CENTER);
                    detailsVisible = true;
                    frame.pack();
                    frame.repaint();
                    frame.validate();
                }
            }
        });

        JButton ok = new JButton("OK");
        ok.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                frame.setVisible(false);
            }
        });

        temp = new JPanel();
        temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
        temp.add(Box.createHorizontalGlue());
        temp.add(showDetails);
        temp.add(Box.createHorizontalStrut(5));
        temp.add(ok);
		temp.setBorder(new EmptyBorder(5,0,0,0));

        frame.getContentPane().add(temp,BorderLayout.SOUTH);

        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        frame.setLocation((d.width - frame.getSize().width)
                / 2, (d.height - frame.getSize().height) / 2);
    }


    public static void showException(String aMessage, Throwable aThrowable)
    {
        if (message == null)
        {
            initMessageBox();
        }
        message.setText(aMessage);
        throwable = aThrowable;
        frame.pack();
        frame.setVisible(true);
    }
}
