/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.data;

/**
 * Use this interface to get and set data for Feature Servers.
 */
public interface CdrData extends HostPortData
{

  /**
   * 
   * @param data
   * 
   * @throws InvalidRequestException
   */
  public void setTypeData(String data) throws InvalidRequestException;

  /**
   * get data for Group field
   */
  public String getGroupData() throws InvalidRequestException;

  /**
   * set data for Group field
   */
  public void setGroupData(String data) throws InvalidRequestException;

  /**
   * get data for Radius Server host field
   */
  public String getRadiusHostData() throws InvalidRequestException;

  /**
   * set data for Radius Server host field
   */
  public void setRadiusHostData(String data) throws InvalidRequestException;

  /**
   * get data for Radius Server retries field
   */
  public String getRadiusRetriesData() throws InvalidRequestException;

  /**
   * set data for Radius Server retries field
   */
  public void setRadiusRetriesData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Radius Server secretKey field
   */
  public String getRadiusSecretKeyData() throws InvalidRequestException;

  /**
   * set data for Radius Server secretKey field
   */
  public void setRadiusSecretKeyData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing frequency field
   */
  public String getBillingFrequencyData() throws InvalidRequestException;

  /**
   * set data for Billing frequency field
   */
  public void setBillingFrequencyData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing directory path field
   */
  public String getBillingDirPathData() throws InvalidRequestException;

  /**
   * set data for Billing directory path field
   */
  public void setBillingDirPathData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing lock file field
   */
  public String getBillingLockFileData() throws InvalidRequestException;

  /**
   * set data for Billing lock file field
   */
  public void setBillingLockFileData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing data file field
   */
  public String getBillingDataFileData() throws InvalidRequestException;

  /**
   * set data for Billing data file field
   */
  public void setBillingDataFileData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing unsent extension field
   */
  public String getBillingUnsentExtensionData() 
    throws InvalidRequestException;

  /**
   * set data for Billing unsent extension field
   */
  public void setBillingUnsentExtensionData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing rollover size field
   */
  public String getBillingRolloverSizeData() throws InvalidRequestException;

  /**
   * set data for Billing rollover size field
   */
  public void setBillingRolloverSizeData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Billing rollover period field
   */
  public String getBillingRolloverPeriodData() throws InvalidRequestException;

  /**
   * set data for Billing rollover period field
   */
  public void setBillingRolloverPeriodData(String data) 
    throws InvalidRequestException;

  /**
   * get data for Bill for Ringtime checkbox
   */
  public boolean getBillForRingtimeData() throws InvalidRequestException;

  /**
   * set data for Bill for Ringtime checkbox
   */
  public void setBillForRingtimeData(boolean data) 
    throws InvalidRequestException;
}



