/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.data;

/**
 * $RCSfile: DataDefaults.java,v $
 * 
 * @author $Author: bsamson $, $Date: 2002/04/15 17:56:23 $
 * @version $Revision: 1.22 $
 */
public interface DataDefaults
{
  public static final String FEATURE_DIR = "Features";
  public static final String MARSHAL_DIR = "Marshals";
  public static final String REDIRECT_DIR = "Redirects";
  public static final String CDR_DIR = "Cdrs";
  public static final String HEARTBEAT_DIR = "Heartbeats";
  public static final String PDP_DIR = "Policy";
  public static final String POLICY_DIR = "Policy";
  public static final String SYSTEM_DIR = "SystemConfiguration";

  public static final String BASE_XML = ("<provisioning>" + "<system/>" 
          + "<servers/>" + "</provisioning>");

  public static final String GLOBAL_CONFIG_FILE = "GlobalConfigData";

  public static final String GLOBAL_CONFIG_XML = ("<globalConfiguration" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + GLOBAL_CONFIG_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.GLOBAL + "\"" + ">" 
          + "<expiryTimer value=\"3600\"/>" 
          + "<multicastHost host=\"224.0.0.100\" port=\"9000\"/>" 
          + "<maxMissedHeartbeats value=\"8\"/>" 
          + "<heartbeatInterval value=\"250\"/>" 
          + "<proxyAuthKey value=\"VovidaClassXSwitch\"/>" 
          + "<redirectReasonInSIP value=\"false\"/>" 
          + "</globalConfiguration>");

  public static final String OSP_SERVER_FILE = "ospServer";

  public static final String OSP_SERVER_XML = ("<ospServer" + " fileDir =\"" 
          + SYSTEM_DIR + "\"" + " fileName =\"" + OSP_SERVER_FILE + "\"" 
          + " fileType =\"" + TreeNodeTypes.OSP_SERVER + "\"" + ">" 
          + "<servicePoints>" + "</servicePoints>" 
          + "<localValidation value=\"1\"/>" + "<sslLifetime value=\"4\"/>" 
          + "<http>" + "<maxConnections value=\"8\"/>" 
          + "<persistence value=\"50000\"/>" + "<retryDelay value=\"100\"/>" 
          + "<retryLimit value=\"3\"/>" + "<timeout value=\"7000\"/>" 
          + "</http>" + "<ospExtension value=\"1\"/>" 
          + "<customerID value=\"10\"/>" + "<deviceID value=\"1000\"/>" 
          + "<auditURL value=\"http://localhost:8888/\"/>" + "</ospServer>");

  public static final String DEFAULT_IP_PLAN_FILE = "defaultIpPlan";

  public static final String DEFAULT_IP_PLAN_XML = ("<ipplan" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + DEFAULT_IP_PLAN_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.IP_DIAL_PLAN + "\"" + ">" + "</ipplan>");
  public static final String DEFAULT_PHONE_PLAN_FILE = "defaultPhonePlan";

  public static final String DEFAULT_PHONE_PLAN_XML = ("<digitalplan" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + DEFAULT_PHONE_PLAN_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.DIGITAL_DIAL_PLAN + "\"" + ">" + "</digitalplan>");

  public static final String LIST_OF_FEATURE_SERVERS_FILE = 
    "ListOfFeatureServers";

  // please add any new types to the end of the list only.
  // see why in FileToDOM.
  public static final String LIST_OF_FEATURE_SERVERS_XML = ("<featureServers" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + LIST_OF_FEATURE_SERVERS_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.FEATURE_SERVERS + "\"" + ">" 
          + "<serverType value=\"ForwardAllCalls\">" 
          + "<serverGroup value=\"ForwardAllCallsGroup\"/>" + "</serverType>" 
          + "<serverType value=\"ForwardNoAnswerBusy\">" 
          + "<serverGroup value=\"ForwardNoAnswerBusyGroup\"/>" 
          + "</serverType>" + "<serverType value=\"CallBlocking\">" 
          + "<serverGroup  value=\"CallBlockingGroup\"/>" + "</serverType>" 
          + "<serverType value=\"CallScreening\">" 
          + "<serverGroup  value=\"CallScreeningGroup\"/>" + "</serverType>" 
          + "<serverType value=\"Voicemail\">" 
          + "<serverGroup value=\"VoicemailGroup\"/>" + "</serverType>" 
          + "<serverType value=\"CallReturn\">" 
          + "<serverGroup  value=\"CallReturnGroup\"/>" + "</serverType>" 
          + "<serverType value=\"CallerIdBlocking\">" 
          + "<serverGroup  value=\"CallerIdBlockingGroup\"/>" 
          + "</serverType>" + "</featureServers>");

  public static final String LIST_OF_MARSHAL_SERVERS_FILE = 
    "ListOfMarshalServers";

  public static final String LIST_OF_MARSHAL_SERVERS_XML = ("<marshalServers" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + LIST_OF_MARSHAL_SERVERS_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.MARSHAL_SERVERS + "\"" + ">" 
          + "<serverType value=\"UserAgent\">" 
          + "<serverGroup value=\"UserAgentGroup\"/>" + "</serverType>" 
          + "<serverType value=\"Gateway\">" 
          + "<serverGroup value=\"GatewayGroup\"/>" + "</serverType>" 
          + "<serverType value=\"ConferenceBridge\">" 
          + "<serverGroup value=\"ConferenceBridgeGroup\"/>" 
          + "</serverType>" + "<serverType value=\"Internetwork\">" 
          + "<serverGroup value=\"InternetworkGroup\"/>" + "</serverType>" 
          + "</marshalServers>");

  public static final String LIST_OF_REDIRECT_SERVERS_FILE = 
    "ListOfRedirectServers";

  public static final String LIST_OF_REDIRECT_SERVERS_XML = 
    ("<redirectServers" + " fileDir =\"" + SYSTEM_DIR + "\"" 
     + " fileName =\"" + LIST_OF_REDIRECT_SERVERS_FILE + "\"" 
     + " fileType =\"" + TreeNodeTypes.REDIRECT_SERVERS + "\"" + ">" 
     + "<serverGroup value=\"RedirectGroup\"/>" + "</redirectServers>");

  public static final String LIST_OF_CDR_SERVERS_FILE = "ListOfCdrServers";

  public static final String LIST_OF_CDR_SERVERS_XML = ("<cdrServers" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + LIST_OF_CDR_SERVERS_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.CDR_SERVERS + "\"" + ">" 
          + "<serverGroup value=\"CdrGroup\"/>" + "</cdrServers>");

  public static final String LIST_OF_PDP_SERVERS_FILE = "ListOfPdpServers";

  public static final String LIST_OF_PDP_SERVERS_XML = ("<pdpServers" 
          + " fileDir =\"" + SYSTEM_DIR + "\"" + " fileName =\"" 
          + LIST_OF_PDP_SERVERS_FILE + "\"" + " fileType =\"" 
          + TreeNodeTypes.PDP_SERVERS + "\"" + ">" 
          + "<serverGroup value=\"PdpGroup\"/>" + "</pdpServers>");

  public static final String LIST_OF_HEARTBEAT_SERVERS_FILE = 
    "ListOfHeartbeatServers";

  public static final String LIST_OF_HEARTBEAT_SERVERS_XML = 
    ("<heartbeatServers" + " fileDir =\"" + SYSTEM_DIR + "\"" 
     + " fileName =\"" + LIST_OF_HEARTBEAT_SERVERS_FILE + "\"" 
     + " fileType =\"" + TreeNodeTypes.HEARTBEAT_SERVERS + "\"" + ">" 
     + "<serverGroup value=\"HeartbeatGroup\"/>" + "</heartbeatServers>");

  public static final String DEPLOYED_SERVERS_FILE = "deployedServers.xml";

}



