/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.data;

/**
 * Use this interface to get and set data for Global Configuration
 */
public interface GlobalData extends HostPortData
{

  /**
   * get data for expiryTimer field
   */
  public String getExpiryTimerData() throws InvalidRequestException;

  /**
   * set data for expiryTimer field
   */
  public void setExpiryTimerData(String data) throws InvalidRequestException;

  /**
   * get data for multicastHost field
   */
  public String getMulticastHostData() throws InvalidRequestException;

  /**
   * set data for multicastHost field
   */
  public void setMulticastHostData(String data) 
    throws InvalidRequestException;

  /**
   * get data for multicastPort field
   */
  public String getMulticastPortData() throws InvalidRequestException;

  /**
   * set data for multicastPort field
   */
  public void setMulticastPortData(String data) 
    throws InvalidRequestException;

  /**
   * get data for missedHeartbeats field
   */
  public String getMissedHeartbeatsData() throws InvalidRequestException;

  /**
   * set data for missedHeartbeats field
   */
  public void setMissedHeartbeatsData(String data) 
    throws InvalidRequestException;

  /**
   * get data for heartbeatInterval field
   */
  public String getHeartbeatIntervalData() throws InvalidRequestException;

  /**
   * set data for heartbeatInterval field
   */
  public void setHeartbeatIntervalData(String data) 
    throws InvalidRequestException;

  /**
   * get data for proxy authorization key field
   */
  public String getProxyAuthKeyData() throws InvalidRequestException;

  /**
   * set data for proxy authorization key field
   */
  public void setProxyAuthKeyData(String data) throws InvalidRequestException;

  /**
   * Find out whether or not Redirect Reason messages
   * are included in SIP headers.
   * @return true if redirect reasons get included.
   */
  public boolean getRedirectReasonData() throws InvalidRequestException;

  /**
   * Set whether or not Redirect Reason messages
   * are included in SIP headers.
   * @param data true if redirect reasons get included.
   */
  public void setRedirectReasonData(boolean data) 
    throws InvalidRequestException;
}



