/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.data;

import java.util.Vector;

/**
 * $RCSfile: OSPData.java,v $
 * 
 * @author $Author: bsamson $, $Date: 2001/01/27 00:42:31 $
 * @version $Revision: 1.9 $
 */
public interface OSPData
{

  /**
   * get data for ServicePointURL field.
   */
  public Vector getServicePointURL() throws InvalidRequestException;

  /**
   * set data for ServicePointURL field.
   */
  public void setServicePointURL(Vector data) throws InvalidRequestException;

  /**
   * get data for LocalValidation field.
   */
  public String getLocalValidation() throws InvalidRequestException;

  /**
   * set data for LocalValidation field.
   */
  public void setLocalValidation(String data) throws InvalidRequestException;

  /**
   * get data for SslLifetime field.
   */
  public String getSslLifetime() throws InvalidRequestException;

  /**
   * set data for SslLifetime field.
   */
  public void setSslLifetime(String data) throws InvalidRequestException;

  /**
   * get data for HttpMaxConnections field.
   */
  public String getHttpMaxConnections() throws InvalidRequestException;

  /**
   * set data for HttpMaxConnections field.
   */
  public void setHttpMaxConnections(String data) 
    throws InvalidRequestException;

  /**
   * get data for HttpPersistence field.
   */
  public String getHttpPersistence() throws InvalidRequestException;

  /**
   * set data for HttpPersistence field.
   */
  public void setHttpPersistence(String data) throws InvalidRequestException;

  /**
   * get data for HttpRetryDelay field.
   */
  public String getHttpRetryDelay() throws InvalidRequestException;

  /**
   * set data for HttpRetryDelay field.
   */
  public void setHttpRetryDelay(String data) throws InvalidRequestException;

  /**
   * get data for HttpRetryLimit field.
   */
  public String getHttpRetryLimit() throws InvalidRequestException;

  /**
   * set data for HttpRetryLimit field.
   */
  public void setHttpRetryLimit(String data) throws InvalidRequestException;

  /**
   * get data for HttpTimeout field.
   */
  public String getHttpTimeout() throws InvalidRequestException;

  /**
   * set data for HttpTimeout field.
   */
  public void setHttpTimeout(String data) throws InvalidRequestException;

  /**
   * get data for OspExtension field.
   */
  public String getOspExtension() throws InvalidRequestException;

  /**
   * set data for OspExtension field.
   */
  public void setOspExtension(String data) throws InvalidRequestException;

  /**
   * get data for CustomerID field.
   */
  public String getCustomerID() throws InvalidRequestException;

  /**
   * set data for CustomerID field.
   */
  public void setCustomerID(String data) throws InvalidRequestException;

  /**
   * get data for DeviceID field.
   */
  public String getDeviceID() throws InvalidRequestException;

  /**
   * set data for DeviceID field.
   */
  public void setDeviceID(String data) throws InvalidRequestException;

  /**
   * get data for AuditURL field.
   */
  public String getAuditURL() throws InvalidRequestException;

  /**
   * set data for AuditURL field.
   */
  public void setAuditURL(String data) throws InvalidRequestException;

  /**
   * save the data
   */
  public void saveData() throws InvalidRequestException;
}



