/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.data;

/**
 * $RCSfile$
 * 
 * @author $Author$, $Date$
 * @version $Revision$
 */
public interface TreeNodeTypes
{

  public static final int UNKNOWN = 0;
  public static final int SYSTEM = 1;
  public static final int SERVERS = 2;
  public static final int GLOBAL = 3;
  public static final int DIGITAL_DIAL_PLAN = 4;
  public static final int IP_DIAL_PLAN = 5;
  public static final int ALIAS_LIST = 6;
  public static final int CDR_SERVERS = 7;
  public static final int CDR_GROUP = 8;
  public static final int FEATURE_SERVERS = 9;
  public static final int FEATURE_TYPE = 10;
  public static final int FEATURE_GROUP = 11;
  public static final int JTAPI_SERVERS = 12;
  public static final int JTAPI_TYPE = 13;
  public static final int JTAPI_GROUP = 14;
  public static final int MARSHAL_SERVERS = 15;
  public static final int MARSHAL_TYPE = 16;
  public static final int MARSHAL_GROUP = 17;
  public static final int PDP_SERVER = 18;
  public static final int PDP_SERVERS = 19;
  public static final int PDP_GROUP = 20;
  public static final int OSP_SERVER = 21;
  public static final int OSP_SERVICE_POINTS = 22;
  public static final int REDIRECT_SERVERS = 23;
  public static final int REDIRECT_SERVER = 24;
  public static final int REDIRECT_GROUP = 25;
  public static final int FEATURE_SERVER = 26;
  public static final int MARSHAL_SERVER = 27;
  public static final int JTAPI_SERVER = 28;
  public static final int CDR_SERVER = 29;
  public static final int HEARTBEAT_SERVERS = 30;
  public static final int HEARTBEAT_GROUP = 31;
  public static final int HEARTBEAT_SERVER = 32;

  public static final String[] strings = 
  {
    "UNKNOWN", "SYSTEM", "SERVERS", "GLOBAL", "DIGITAL_DIAL_PLAN", 
    "IP_DIAL_PLAN", "ALIAS_LIST", "CDR_SERVERS", "CDR_GROUP", 
    "FEATURE_SERVERS", "FEATURE_TYPE", "FEATURE_GROUP", "JTAPI_SERVERS", 
    "JTAPI_TYPE", "JTAPI_GROUP", "MARSHAL_SERVERS", "MARSHAL_TYPE", 
    "MARSHAL_GROUP", "PDP_SERVER", "PDP_SERVERS", "PDP_GROUP", "OSP_SERVER", 
    "OSP_SERVICE_POINTS", "REDIRECT_SERVERS", "REDIRECT_SERVER", 
    "REDIRECT_GROUP", "FEATURE_SERVER", "MARSHAL_SERVER", "JTAPI_SERVER", 
    "CDR_SERVER", "HEARTBEAT_SERVERS", "HEARTBEAT_GROUP", "HEARTBEAT_SERVER"
  };
}



