/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.ui;

import java.text.ParseException;

import java.util.Vector;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;
import vocal.data.TreeNodeTypes;
import javax.swing.*;

/**
 * $RCSfile: FormPanelScreen.java,v $
 * 
 * @author $Author: bsamson $, $Date: 2001/01/27 00:42:33 $
 * @version $Revision: 1.11 $
 */
public class FormPanelScreen extends JPanel implements ActionListener, 
        TreeNodeTypes
{

  /**
   */
  public FormPanelScreen()
  {
    try
    {
      jbInit();

      toValidate = new Vector();

      toValidate.clear();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  /**
   * 
   * @param e
   */
  public void actionPerformed(ActionEvent e) {}

  /**
   * 
   */
  protected FormPanelScreen getNewScreen()
  {

    // overridden in derived classes where it makes sense.
    return this;
  }

  /**
   */
  protected void activate()
  {

    // this is overridden in the derived classes.
  }

  /**
   */
  protected void activateNew()
  {

    // this is overriden in the derived classes where it makes sense.
  }


  /**
   */
  public void displayData()
  {

    // this is overriden in the derived classes.
  }

  /**
   * 
   */
  public int confirmDelete()
  {
    return JOptionPane.NO_OPTION;
  }

  protected void cancelCalled()
  {

    // this is overriden in the derived classes that need it
  }


  protected boolean checkValidated()
  {

    for (int i = 0; i < toValidate.size(); i++)
    {

      ValidatingField toCheck = (ValidatingField) toValidate.elementAt(i);

      try
      {
        toCheck.verifyContent();
      }
      catch (ParseException e)
      {
        System.err.println("remove: could not parse: " + e.getMessage());
        JOptionPane.showMessageDialog(this.getTopLevelAncestor(), 
                e.getMessage(), "Invalid Input", JOptionPane.ERROR_MESSAGE);

        return false;
      }

    }

    return true;

  }



  /**
   * 
   * @throws Exception
   */
  private void jbInit() throws Exception {}

  protected Vector toValidate;

}




