/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package vocal.ui;

import java.util.Vector;
import java.awt.*;
import javax.swing.event.*;
import javax.swing.*;
import vocal.data.OSPData;
import vocal.data.InvalidRequestException;
import vocal.data.TreeNodeTypes;
import vocal.data.ConfigTree;
import javax.swing.border.Border;

import javax.swing.table.TableColumn;
import java.awt.event.*;

/**
 * $RCSfile: OSPServerScreen.java,v $
 * 
 * @author $Author: bsamson $, $Date: 2001/01/27 00:42:33 $
 * @version $Revision: 1.15 $
 */
public class OSPServerScreen extends FormPanelScreen
{
  JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  ConfigTree configTree1;
  OSPData dataManager;
  ConfigureServers mainScreen;

  JPanel jPanel3 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel jPanel4 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  Box box1;
  JPanel jPanel5 = new JPanel();
  JLabel serverNameLabel = new JLabel();
  Box box2;
  JLabel httpRetryDelayLabel = new JLabel();
  WholeNumberField httpMaxConnectionsField = 
    new WholeNumberField("HTTP Max Connections");
  WholeNumberField httpRetryLimitField = 
    new WholeNumberField("HTTP Retry Limit");
  InternalClipboardField ospExtensionField = new InternalClipboardField();
  InternalClipboardField localValidationField = new InternalClipboardField();
  JLabel customerIDLabel = new JLabel();
  JLabel sslLifetimeLabel = new JLabel();
  JLabel httpPersistenceLabel = new JLabel();
  JLabel auditURLLabel = new JLabel();
  WholeNumberField httpRetryDelayField = 
    new WholeNumberField("HTTP Retry Delay");
  JLabel deviceIDLabel = new JLabel();
  JLabel httpTimeoutLabel = new JLabel();
  WholeNumberField customerIDField = new WholeNumberField("Customer ID");
  WholeNumberField sslLifetimeField = new WholeNumberField("SSL Lifetime");
  LabelFieldPanel labelFieldPanel1 = new LabelFieldPanel();
  WholeNumberField httpPersistenceField = 
    new WholeNumberField("HTTP Persistance");
  InternalClipboardField auditURLField = new InternalClipboardField();
  JLabel httpMaxConnectionsLabel = new JLabel();
  JLabel httpRetryLimitLabel = new JLabel();
  JLabel ospExtensionLabel = new JLabel();
  JLabel localValidationLabel = new JLabel();
  WholeNumberField deviceIDField = new WholeNumberField("Device ID");
  WholeNumberField httpTimeoutField = new WholeNumberField("HTTP Timeout");
  JPanel tablePanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTable jTable1 = new JTable();
  TableColumn tableColumn = new TableColumn();
  BasicTableModel tableModel = new BasicTableModel();
  JPanel jPanel6 = new JPanel();
  FlowLayout flowLayout3 = new FlowLayout();
  JPanel jPanel7 = new JPanel();
  JPanel jPanel8 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JButton tableAddButton = new JButton();
  JButton tableDeleteButton = new JButton();
  JLabel tableLabel = new JLabel();
  FlowLayout flowLayout4 = new FlowLayout();

  /**
   * 
   * @param screen
   */
  public OSPServerScreen(ConfigureServers screen)
  {
    mainScreen = screen;

    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

    initTable();
  }

  /**
   */
  private void initTable()
  {
    jTable1.setModel(tableModel);
    tableColumn.setPreferredWidth(180);
    tableColumn.setCellEditor(new DefaultCellEditor(new InternalClipboardField()));
    jTable1.addColumn(tableColumn);
    jTable1.setCellSelectionEnabled(true);
    jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  }


  /**
   * 
   * @throws Exception
   */
  private void jbInit() throws Exception
  {

    box1 = Box.createVerticalBox();
    box2 = Box.createVerticalBox();

    this.setLayout(borderLayout2);
    jPanel1.setLayout(borderLayout1);
    borderLayout2.setVgap(30);
    jPanel2.setLayout(borderLayout4);
    borderLayout1.setVgap(20);
    jPanel3.setLayout(flowLayout1);
    jPanel4.setBorder(BorderFactory.createEmptyBorder(20, 0, 0, 0));
    jPanel4.setMinimumSize(new Dimension(500, 100));
    jPanel4.setPreferredSize(new Dimension(300, 50));
    jPanel4.setLayout(flowLayout2);
    flowLayout1.setVgap(10);
    borderLayout4.setVgap(20);
    serverNameLabel.setForeground(Color.black);
    serverNameLabel.setText("OSP Server ");
    jPanel3.setMinimumSize(new Dimension(100, 400));
    jPanel3.setPreferredSize(new Dimension(300, 580));
    httpRetryDelayLabel.setForeground(Color.black);
    httpRetryDelayLabel.setText("HTTP Retry Delay (s):");
    customerIDLabel.setForeground(Color.black);
    customerIDLabel.setText("Customer ID:");
    sslLifetimeLabel.setForeground(Color.black);
    sslLifetimeLabel.setText("SSL Lifetime (s):");
    httpPersistenceLabel.setForeground(Color.black);
    httpPersistenceLabel.setToolTipText("");
    httpPersistenceLabel.setText("HTTP Persistence (s):");
    auditURLLabel.setForeground(Color.black);
    auditURLLabel.setText("Audit URL:");
    deviceIDLabel.setForeground(Color.black);
    deviceIDLabel.setText("Device ID:");
    httpTimeoutLabel.setForeground(Color.black);
    httpTimeoutLabel.setText("HTTP Timeout (ms):");
    labelFieldPanel1.setMinimumSize(new Dimension(100, 400));
    labelFieldPanel1.setPreferredSize(new Dimension(310, 440));
    labelFieldPanel1.setHorizontalGap(30);
    labelFieldPanel1.setVerticalGap(20);
    httpMaxConnectionsLabel.setForeground(Color.black);
    httpMaxConnectionsLabel.setText("HTTP Max Connections:");
    httpRetryLimitLabel.setForeground(Color.black);
    httpRetryLimitLabel.setText("HTTP Retry Limit:");
    ospExtensionLabel.setForeground(Color.black);
    ospExtensionLabel.setText("OSP Extension:");
    localValidationLabel.setForeground(Color.black);
    localValidationLabel.setText("Local Validation:");
    tablePanel.setLayout(borderLayout3);
    jScrollPane2.setPreferredSize(new Dimension(300, 80));
    tablePanel.setPreferredSize(new Dimension(300, 140));
    tablePanel.setToolTipText("URLs for sending OSP requests and indications");
    jPanel6.setLayout(flowLayout3);
    jPanel8.setLayout(gridLayout1);
    tableAddButton.setToolTipText("add new entry to table");
    tableAddButton.setText("Add");
    tableAddButton.addActionListener(new java.awt.event.ActionListener()
    {

      /**
       * 
       * @param e
       */
      public void actionPerformed(ActionEvent e)
      {
        tableAddButton_actionPerformed(e);
      }

    });
    tableDeleteButton.setToolTipText("delete selected entry");
    tableDeleteButton.setText("Delete");
    tableDeleteButton.addActionListener(new java.awt.event.ActionListener()
    {

      /**
       * 
       * @param e
       */
      public void actionPerformed(ActionEvent e)
      {
        tableDeleteButton_actionPerformed(e);
      }

    });
    tableLabel.setForeground(Color.black);
    tableLabel.setText("URL Entries:");
    gridLayout1.setColumns(2);
    this.setPreferredSize(new Dimension(303, 640));
    jPanel1.setPreferredSize(new Dimension(303, 640));
    jScrollPane1.setPreferredSize(new Dimension(303, 640));
    jPanel2.setPreferredSize(new Dimension(300, 640));
    jPanel8.setPreferredSize(new Dimension(170, 30));
    jPanel7.setLayout(flowLayout4);
    flowLayout4.setVgap(2);
    flowLayout3.setVgap(2);
    jPanel6.setPreferredSize(new Dimension(190, 50));
    localValidationField.setToolTipText("ignored in current version");
    sslLifetimeField.setToolTipText("lifetimeof a single Secured Socket Layer session key");
    httpMaxConnectionsField.setToolTipText("maximum number of simultaneous connections to the OSP server");
    httpPersistenceField.setToolTipText("time that an HTTP connection is maintained after exchange");
    httpRetryDelayField.setToolTipText("time between connection retry attempts");
    httpRetryLimitField.setToolTipText("maximum number of attempts to connect to OSP server");
    httpTimeoutField.setToolTipText("maximum time to wait for response from OSP server");
    ospExtensionField.setToolTipText("\"1\" to connect OSP client with a TransNexusOSP server, \"0\" otherwise");
    customerIDField.setToolTipText("assigned by settlement provider as a unique customer identification " 
            + "code");
    deviceIDField.setToolTipText("assigned by settlement provider as unique device identification code");
    auditURLField.setToolTipText("URL used for OSP audits");
    jTable1.setToolTipText("");
    this.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jPanel2, null);
    jPanel2.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(box2, null);
    box2.add(labelFieldPanel1, null);
    labelFieldPanel1.add(localValidationLabel, null);
    labelFieldPanel1.add(localValidationField, null);
    labelFieldPanel1.add(sslLifetimeLabel, null);
    labelFieldPanel1.add(sslLifetimeField, null);
    labelFieldPanel1.add(httpMaxConnectionsLabel, null);
    labelFieldPanel1.add(httpMaxConnectionsField, null);
    labelFieldPanel1.add(httpPersistenceLabel, null);
    labelFieldPanel1.add(httpPersistenceField, null);
    labelFieldPanel1.add(httpRetryDelayLabel, null);
    labelFieldPanel1.add(httpRetryDelayField, null);
    labelFieldPanel1.add(httpRetryLimitLabel, null);
    labelFieldPanel1.add(httpRetryLimitField, null);
    labelFieldPanel1.add(httpTimeoutLabel, null);
    labelFieldPanel1.add(httpTimeoutField, null);
    labelFieldPanel1.add(ospExtensionLabel, null);
    labelFieldPanel1.add(ospExtensionField, null);
    labelFieldPanel1.add(customerIDLabel, null);
    labelFieldPanel1.add(customerIDField, null);
    labelFieldPanel1.add(deviceIDLabel, null);
    labelFieldPanel1.add(deviceIDField, null);
    labelFieldPanel1.add(auditURLLabel, null);
    labelFieldPanel1.add(auditURLField, null);
    box2.add(tablePanel, null);
    tablePanel.add(jScrollPane2, BorderLayout.CENTER);
    tablePanel.add(jPanel6, BorderLayout.SOUTH);
    jPanel6.add(jPanel7, null);
    jPanel7.add(jPanel8, null);
    jPanel8.add(tableAddButton, null);
    jPanel8.add(tableDeleteButton, null);
    tablePanel.add(tableLabel, BorderLayout.NORTH);
    jScrollPane2.getViewport().add(jTable1, null);
    jPanel2.add(jPanel4, BorderLayout.NORTH);
    jPanel4.add(box1, null);
    box1.add(jPanel5, null);
    jPanel5.add(serverNameLabel, null);

    configTree1 = mainScreen.getConfigTree();

  }


  /**
   */
  public void displayData()
  {
    if (dataManager != null)
    {
      try
      {
        localValidationField.setText(dataManager.getLocalValidation());
        sslLifetimeField.setText(dataManager.getSslLifetime());
        httpMaxConnectionsField.setText(dataManager.getHttpMaxConnections());
        httpPersistenceField.setText(dataManager.getHttpPersistence());
        httpRetryDelayField.setText(dataManager.getHttpRetryDelay());
        httpRetryLimitField.setText(dataManager.getHttpRetryLimit());
        httpTimeoutField.setText(dataManager.getHttpTimeout());
        ospExtensionField.setText(dataManager.getOspExtension());
        customerIDField.setText(dataManager.getCustomerID());
        deviceIDField.setText(dataManager.getDeviceID());
        auditURLField.setText(dataManager.getAuditURL());
        tableModel.setData(dataManager.getServicePointURL());

        toValidate.clear();
        toValidate.add(sslLifetimeField);
        toValidate.add(httpMaxConnectionsField);
        toValidate.add(httpPersistenceField);
        toValidate.add(httpRetryDelayField);
        toValidate.add(httpRetryLimitField);
        toValidate.add(httpTimeoutField);
        toValidate.add(customerIDField);
        toValidate.add(deviceIDField);


      }
      catch (InvalidRequestException e)
      {
        e.printStackTrace();
      }
    }
  }

  /**
   */
  public void getData()
  {
    try
    {
      dataManager.setLocalValidation(localValidationField.getText());
      dataManager.setSslLifetime(sslLifetimeField.getText());
      dataManager.setHttpMaxConnections(httpMaxConnectionsField.getText());
      dataManager.setHttpPersistence(httpPersistenceField.getText());
      dataManager.setHttpRetryDelay(httpRetryDelayField.getText());
      dataManager.setHttpRetryLimit(httpRetryLimitField.getText());
      dataManager.setHttpTimeout(httpTimeoutField.getText());
      dataManager.setOspExtension(ospExtensionField.getText());
      dataManager.setCustomerID(customerIDField.getText());
      dataManager.setDeviceID(deviceIDField.getText());
      dataManager.setAuditURL(auditURLField.getText());
      dataManager.setServicePointURL(tableModel.getTableData());
    }
    catch (InvalidRequestException e)
    {
      e.printStackTrace();
    }
  }

  /**
   */
  public void activate()
  {
    dataManager = configTree1.getOSPData();

    displayData();
  }

  // Action Listener

  /**
   * 
   * @param ev
   */
  public void actionPerformed(ActionEvent ev)
  {

    if (ev.getSource() == mainScreen.getOkButton())
    {

      if (!checkValidated())
      {
        return;
      }


      // this simulates a mouse click
      CellEditor cellEditor = jTable1.getCellEditor();

      if (cellEditor != null)
      {
        cellEditor.stopCellEditing();
      }

      getData();

      if (dataManager != null)
      {
        try
        {
          dataManager.saveData();
        }
        catch (InvalidRequestException e) {}
      }

      dataManager = configTree1.getOSPData();

      mainScreen.enableTree();

    }

  }

  /**
   * 
   * @param e
   */
  void tableAddButton_actionPerformed(ActionEvent e)
  {

    // int lastRow = tableModel.getRowCount();
    tableModel.addNewEntry(new String(""));
    tableModel.fireTableRowsInserted(0, 0);
  }

  /**
   * 
   * @param e
   */
  void tableDeleteButton_actionPerformed(ActionEvent e)
  {
    int selectedRow = jTable1.getSelectedRow();

    if (selectedRow > -1)
    {
      tableModel.deleteRow(selectedRow);
      tableModel.fireTableRowsDeleted(selectedRow, selectedRow);
    }

  }

}



