/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package vocal.ui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import vocal.data.GlobalData;
import vocal.data.InvalidRequestException;
import vocal.data.TreeNodeTypes;
import vocal.data.ConfigTree;
import javax.swing.border.Border;

/**
 * $RCSfile$
 * 
 * @author $Author$, $Date$
 * @version $Revision$
 */
public class SystemData extends FormPanelScreen
{
  JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel jPanel2 = new JPanel();
  LabelFieldPanel labelFieldPanel1 = new LabelFieldPanel();
  JLabel jLabel1 = new JLabel();
  WholeNumberField expTimerField = new WholeNumberField("Expiry Timer");
  HostNameField multiHostField = new HostNameField("Host Name");
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  WholeNumberField hbIntervalField = 
    new WholeNumberField("HeartBeat Interval");
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();

  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JLabel jLabel4 = new JLabel();
  BorderLayout borderLayout4 = new BorderLayout();
  ConfigTree configTree1;
  GlobalData dataManager;
  ConfigureServers mainScreen;
  JLabel missedHbLabel = new JLabel();
  WholeNumberField missedHbField = 
    new WholeNumberField("Max Missed HeartBeats");
  FlowLayout flowLayout1 = new FlowLayout();
  JLabel jLabel5 = new JLabel();
  WholeNumberField portField = new WholeNumberField("Multicast Port");
  FlowLayout flowLayout2 = new FlowLayout();
  protected JLabel proxyAuthKeyLabel = new JLabel();
  protected InternalClipboardField proxyAuthKeyTextField = 
    new InternalClipboardField();
  private JCheckBox redirectReasonCheckBox = new JCheckBox();
  private JLabel dummyLabel = new JLabel();

  /**
   * 
   * @param screen
   */
  public SystemData(ConfigureServers screen)
  {
    mainScreen = screen;

    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }


  /**
   * 
   * @throws Exception
   */
  private void jbInit() throws Exception
  {
    this.setLayout(borderLayout2);
    jPanel1.setLayout(borderLayout1);
    jPanel2.setLayout(borderLayout4);
    labelFieldPanel1.setMaximumSize(new Dimension(500, 250));
    labelFieldPanel1.setMinimumSize(new Dimension(320, 250));
    labelFieldPanel1.setPreferredSize(new Dimension(320, 260));
    labelFieldPanel1.setHorizontalGap(15);
    labelFieldPanel1.setVerticalGap(20);
    jLabel1.setFont(new java.awt.Font("SansSerif", 1, 12));
    jLabel1.setForeground(Color.black);
    jLabel1.setText("Expiry Timer (s):");
    jLabel2.setForeground(Color.black);
    jLabel2.setText("Multicast Host:");
    jLabel3.setForeground(Color.black);
    jLabel3.setText("HeartBeat Interval (ms):");
    jPanel3.setBorder(BorderFactory.createEmptyBorder(20, 0, 0, 0));
    jPanel3.setLayout(flowLayout2);
    jPanel4.setLayout(flowLayout1);
    jLabel4.setFont(new java.awt.Font("SansSerif", 1, 12));
    jLabel4.setForeground(Color.black);
    jLabel4.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel4.setText("System Configuration Data");
    borderLayout2.setVgap(30);
    borderLayout1.setVgap(30);
    borderLayout4.setVgap(20);
    missedHbLabel.setForeground(Color.black);
    missedHbLabel.setText("Max. Missed HeartBeats:");
    flowLayout1.setVgap(50);
    jLabel5.setForeground(Color.black);
    jLabel5.setText("Multicast Port:");
    jPanel4.setMaximumSize(new Dimension(500, 250));
    jPanel4.setMinimumSize(new Dimension(320, 250));
    jPanel4.setPreferredSize(new Dimension(320, 250));
    proxyAuthKeyLabel.setForeground(Color.black);
    proxyAuthKeyLabel.setText("Proxy Authorization Key:");
    redirectReasonCheckBox.setHorizontalTextPosition(SwingConstants.LEADING);
    redirectReasonCheckBox.setToolTipText("check to include reason for redirection in SIP headers");
    redirectReasonCheckBox.setText("Redirect Reason in SIP:");
    redirectReasonCheckBox.setActionCommand("Include Redirect Reason in SIP Headers:");
    dummyLabel.setPreferredSize(new Dimension(4, 17));
    expTimerField.setToolTipText("maximum time user can remain registered with the system until another " 
            + "SIP Register message must be sent");
    multiHostField.setToolTipText("IP address used to send heartbeat broadcasts");
    portField.setToolTipText("UDP port used to listen to heartbeat broadcasts");
    hbIntervalField.setToolTipText("transmission rate for heartbeats");
    missedHbField.setToolTipText("number of heartbeats an application can miss before its status becomes " 
            + "inactive");
    proxyAuthKeyTextField.setToolTipText("word that uniquely identifies this system");
    this.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jPanel2, null);
    jPanel2.add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(jLabel4, null);
    jPanel2.add(jPanel4, BorderLayout.CENTER);
    jPanel4.add(labelFieldPanel1, null);
    labelFieldPanel1.add(jLabel1, null);
    labelFieldPanel1.add(expTimerField, null);
    labelFieldPanel1.add(jLabel2, null);
    labelFieldPanel1.add(multiHostField, null);
    labelFieldPanel1.add(jLabel5, null);
    labelFieldPanel1.add(portField, null);
    labelFieldPanel1.add(jLabel3, null);
    labelFieldPanel1.add(hbIntervalField, null);
    labelFieldPanel1.add(missedHbLabel, null);
    labelFieldPanel1.add(missedHbField, null);
    labelFieldPanel1.add(proxyAuthKeyLabel, null);
    labelFieldPanel1.add(proxyAuthKeyTextField, null);
    labelFieldPanel1.add(redirectReasonCheckBox, null);
    labelFieldPanel1.add(dummyLabel, null);

    configTree1 = mainScreen.getConfigTree();
  }

  /**
   * 
   */
  public String getExpTimerField()
  {
    return expTimerField.getText();
  }

  /**
   * 
   */
  public String getMultiHostField()
  {
    return multiHostField.getText();
  }

  /**
   * 
   */
  public String getPortrField()
  {
    return portField.getText();
  }

  /**
   * 
   */
  public String gethbIntervalField()
  {
    return hbIntervalField.getText();
  }

  /**
   * 
   */
  public String getMissedHbField()
  {
    return missedHbField.getText();
  }

  /**
   * 
   * @param str
   */
  public void setExpTimerField(String str)
  {
    expTimerField.setText(str);
  }

  /**
   * 
   * @param str
   */
  public void setMultiHostField(String str)
  {
    multiHostField.setText(str);
  }

  /**
   * 
   * @param str
   */
  public void setPortrField(String str)
  {
    portField.setText(str);
  }

  /**
   * 
   * @param str
   */
  public void sethbIntervalField(String str)
  {
    hbIntervalField.setText(str);
  }

  /**
   * 
   * @param str
   */
  public void setMissedHbField(String str)
  {
    missedHbField.setText(str);
  }

  /**
   */
  public void displayData()
  {
    if (dataManager != null)
    {
      try
      {
        setExpTimerField(dataManager.getExpiryTimerData());
        setMultiHostField(dataManager.getMulticastHostData());
        setPortrField(dataManager.getMulticastPortData());
        sethbIntervalField(dataManager.getHeartbeatIntervalData());
        setMissedHbField(dataManager.getMissedHeartbeatsData());
        proxyAuthKeyTextField.setText(dataManager.getProxyAuthKeyData());
        redirectReasonCheckBox.setSelected(dataManager.getRedirectReasonData());

        toValidate.clear();
        toValidate.add(expTimerField);
        toValidate.add(multiHostField);
        toValidate.add(portField);
        toValidate.add(hbIntervalField);
        toValidate.add(missedHbField);

      }
      catch (InvalidRequestException e)
      {
        e.printStackTrace();
      }
    }
  }

  /**
   */
  protected void getData()
  {
    if (dataManager != null)
    {
      try
      {
        dataManager.setExpiryTimerData(getExpTimerField());
        dataManager.setMulticastHostData(getMultiHostField());
        dataManager.setMulticastPortData(getPortrField());
        dataManager.setHeartbeatIntervalData(gethbIntervalField());
        dataManager.setMissedHeartbeatsData(getMissedHbField());
        dataManager.setProxyAuthKeyData(proxyAuthKeyTextField.getText());
        dataManager.setRedirectReasonData(redirectReasonCheckBox.isSelected());
      }
      catch (InvalidRequestException e)
      {
        e.printStackTrace();
      }
    }
  }

  /**
   */
  public void activate()
  {
    dataManager = configTree1.getGlobalData();

    displayData();
  }

  // Action Listener

  /**
   * 
   * @param ev
   */
  public void actionPerformed(ActionEvent ev)
  {
    if (ev.getSource() == mainScreen.getOkButton())
    {
      System.out.println("\n Systemdata -> Ok Button Pressed");

      if (!checkValidated())
      {
        return;
      }

      dataManager = configTree1.getGlobalData();

      getData();

      if (dataManager != null)
      {
        try
        {
          dataManager.saveData();
        }
        catch (InvalidRequestException e) {}
      }

      dataManager = configTree1.getGlobalData();

      mainScreen.enableTree();
    }
  }

}



