/*
 * ====================================================================
 * The Vovida Software License, Version 1.0
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 * and "Vovida Open Communication Application Library (VOCAL)" must
 * not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact vocal@vovida.org.
 * 
 * 4. Products derived from this software may not be called "VOCAL", nor
 * may "VOCAL" appear in their name, without prior written
 * permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 * 
 */

package vocal.userEditor;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.border.EmptyBorder;

public class CallScreeningTableEditor extends JDialog
{
  JTextField name;
  JTextField number;

  JButton ok;
  JButton cancel;

  boolean okClicked = false;

  public CallScreeningTableEditor()
  {
    this.setTitle("Screen Calls From: ");

    name = new JTextField("");

    name.setToolTipText("use this field to remember whose number this is");

    number = new JTextField("");

    number.setToolTipText("enter phone number to screen");

    ok = new JButton("Ok");
    cancel = new JButton("Cancel");

    getContentPane().setLayout(new BoxLayout(getContentPane(), 
            BoxLayout.Y_AXIS));

    JPanel contents = new JPanel();

    contents.setLayout(new BoxLayout(contents, BoxLayout.Y_AXIS));
    contents.setBorder(new EmptyBorder(3, 3, 3, 3));

    JPanel temp = new JPanel();

    temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
    temp.add(new JLabel("Name: "));
    temp.add(Box.createHorizontalGlue());

    contents.add(temp);
    contents.add(name);

    temp = new JPanel();

    temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
    temp.add(new JLabel("Number: "));
    temp.add(Box.createHorizontalGlue());

    contents.add(temp);
    contents.add(number);

    temp = new JPanel();

    temp.setLayout(new BoxLayout(temp, BoxLayout.X_AXIS));
    temp.setBorder(new EmptyBorder(5, 0, 0, 0));
    temp.add(Box.createHorizontalGlue());
    temp.add(Box.createHorizontalStrut(50));
    temp.add(ok);
    temp.add(cancel);

    contents.add(temp);
    getContentPane().add(contents);

    createListeners();

    this.setModal(true);
  }

  private void createListeners()
  {
    ok.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        okClicked = true;

        CallScreeningTableEditor.this.setVisible(false);
      }

    });

    cancel.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        okClicked = false;

        CallScreeningTableEditor.this.setVisible(false);
      }

    });

  }

  public String getName()
  {
    return name.getText();
  }

  public String getNumber()
  {
    return number.getText();
  }

  public boolean isOkClicked()
  {
    return okClicked;
  }

  public void clear()
  {
    okClicked = false;

    name.setText("");
    number.setText("");
  }

}

