
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const tClient_cxx_Version =
    "$Id: tClient.cxx,v 1.13 2001/05/13 11:04:36 icahoon Exp $";

#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <string>
#include <algo.h>

#include "ProvisionInterface.hxx"
#include "VException.hxx"
#include "VNetworkException.hxx"
#include "VFile.hxx"
#include "VFileBrowser.hxx"
#include "VEnvVar.hxx"
#include <string>

ProvisionInterface &pif = ProvisionInterface::instance("cktam-lnx", 6005, "cktam-lnx", 6010);

void notifyUpdate(const string& data, const string& fileName, bool flag)
{
    cerr << "Received an update notification for file :" << fileName << endl;
    cerr << "Received an update notification for Data :" << data << endl;
    cerr << "Flag                                     :" << flag << endl;
    list < string > marshals;
    pif.getMarshalServers(marshals);
    list < string > ::iterator itr2;
    for (itr2 = marshals.begin(); itr2 != marshals.end(); itr2++)
    {
        cerr << (*itr2) << endl;
    }
    cerr << "Callback done!" << endl;
}

int
main(int argc, char** argv)
{
    char c;
    extern char *optarg;
    cpLogSetPriority (LOG_DEBUG);

    string fName, contents, dirName, fileName;
    cerr << "starting test" << endl;

    try
    {

        pif.registerForUpdate(notifyUpdate, "ListOfMarshalServers",
                              ProvisionInterface::VCONFIG);

        sleep(1000);

    }
    catch (VException& e)
    {
        cerr << "Application failed." << endl;
    }
    catch (VNetworkException& e)
    {
        cerr << "Network exception ." << e.getDescription() << endl;
    }
    exit(0);
}
