
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const testClient_cxx_Version =
    "$Id: testClient.cxx,v 1.8 2001/05/13 11:04:36 icahoon Exp $";
/*
 *
 * testClient.cxx
 *
 */


#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <string>

#include "ProvisionInterface.hxx"
#include "VException.hxx"
#include "VNetworkException.hxx"
#include "cpLog.h"


#include "Provision.h"
#include "ConnectPserver.h"
#include "Feature.h"
#include "Cdr.h"
#include "Heartbeat.h"
#include "Jtapi.h"
#include "Marshal.h"
#include "Osp.h"
#include "Policy.h"
#include "Redirect.h"

#include "AutomatedTest.h"

// Copyright (C) 2000 by Vovida Networks, Inc.

char choice;


void
ShowMenu()
{
    cout << endl;
    cout << "(C)dr Servers" << endl;
    cout << "(E)xit" << endl;
    cout << "(F)eature Servers" << endl;
    cout << "(H)eartbeat Servers" << endl;
    cout << "(J)TAPI Servers" << endl;
    cout << "(M)arshal Servers" << endl;
    cout << "(O)sp Servers" << endl;
    cout << "(P)olicy Servers" << endl;
    cout << "Pro(V)ision Server" << endl;
    cout << "(R)edirect Servers" << endl;
    cout << "(A) Server test (Automated)" << endl;
    cout << "(B) Subcriber test (Automated)" << endl << endl;

    cout << "Enter your choice: ";
    cin >> choice;
    cout << endl;

}

int
main(int argc, char** argv)
{
    if (argc == 2)
    {
        if (! strcmp(argv[1], "debug"))
            cpLogSetPriority (LOG_DEBUG);
    }

    cout << endl;
    cout << "**********************************" << endl;
    cout << "*                                *" << endl;
    cout << "*     Test Client Program        *" << endl;
    cout << "*                                *" << endl;
    cout << "* Note: Turn on debug message:   *" << endl;
    cout << "*       ./testClient debug       *" << endl;
    cout << "*                                *" << endl;
    cout << "**********************************" << endl << endl;

    while (true)
    {
        ShowMenu();
        switch (choice)
        {
            case 'C':
            case 'c':
                cdrServers();
            break;
            case 'E': case 'e':
                exit(0);
            break;
            case 'F': case 'f':
                featureServers();
            break;
            case 'H': case 'h':
                heartbeatServers();
            break;
            case 'J': case 'j':
                jtapiServers();
            break;
            case 'M': case 'm':
                marshalServers();
            break;
            case 'O': case 'o':
                ospServers();
            break;
            case 'P': case 'p':
                policyServers();
            break;
            case 'R': case 'r':
                redirectServers();
            break;
            case 'V': case 'v':
                provisionServer();
            break;
            case 'A': case 'a':
                automatedTest();
            break;
            case 'B': case 'b':
                subscriberTest();
            break;
            default:
                cout << "Don't know your choice: " << choice << ". Stop!!!" << endl;
            exit(0);
        }
    }

}
