
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const VFeatureServerGroupContainer_cxx_Version =
    "$Id: VFeatureServerGroupContainer.cxx,v 1.13 2001/01/24 21:20:38 dabryan Exp $";

#include <stdio.h>
#include <iostream.h>

#if defined (__linux__)
#include <algo.h>
#endif
#include <cassert>
#include "VXmlParser.hxx"
#include "VPs_def.h"
#include "VFeatureServerGroupContainer.hxx"
#include "VBadDataException.hxx"
#include "cpLog.h"
#include "VException.hxx"


/*
void
VFeatureServerGroupContainer::initializeMap(const string& dataInput)
throw (VException&)
{

    if (!_updateServerGrpMap)
    {
        return ;
    }

    _data = dataInput;
    _serverGrpMap.erase(_serverGrpMap.begin(), _serverGrpMap.end());
    cpLog(LOG_DEBUG, "Calling initializeMap for VFeatureServerGroupContainer");

    // ensure they passed us some data (the XML to parse) and setup a parser
    assert(dataInput.size());

    try
    {
        VXmlParser parser(dataInput);

        // generate a list, one entry for every serverType
        list < xmlNodePtr > listOfServerTypes;
        parser.findNode(NULL, "serverType", listOfServerTypes);

        // iterate throught the serverType list
        for (list < xmlNodePtr > ::iterator itr = listOfServerTypes.begin();
                itr != listOfServerTypes.end(); itr++)
        {
            xmlNodePtr serverNode = (*itr);
            // get value attribute from node
            string fType = parser.getAttribute(serverNode, "value");

            // get a list of the serverGroups within a particular serverType
            list < xmlNodePtr > listOfFeatureGroups;
            parser.findNode(serverNode, "serverGroup", listOfFeatureGroups);

            for (list < xmlNodePtr > ::iterator itr2 = listOfFeatureGroups.begin();
                    itr2 != listOfFeatureGroups.end(); itr2++)
            {
                xmlNodePtr groupNode = (*itr2);
                string groupName = parser.getAttribute(groupNode, "value");
                list < xmlNodePtr > listOfServers;
                parser.findNode(groupNode, "server", listOfServers);
                for (list < xmlNodePtr > ::iterator itr3 = listOfServers.begin();
                        itr3 != listOfServers.end(); itr3++)
                {
                    xmlNodePtr sNode = (*itr3);
                    string hostName = parser.getAttribute(sNode, "host");
                    string port = parser.getAttribute(sNode, "port");
                    //Save data as host/port
                    hostName += ":";
                    hostName += port;

                    // create a list of concatanated host/port names
                    // the serverType indexes to ServerGroups maps, and index
                    // it to list of host/port nams
                    GroupMap& gMap = _serverGrpMap[fType];
                    gMap[groupName].push_back(hostName);

                }

            }

        }

    }
    catch (VBadDataException& e)
    {
        cpLog(LOG_DEBUG, "Failed to get details for feature %s",
              e.getDescription().c_str());
    }

    _updateServerGrpMap = false;

}
*/


string
VFeatureServerGroupContainer::getFeatureAcronym(const string& detName)
{

    //Add more description as we know more features
    string retString(detName);
    if (detName == string("ForwardNoAnswer"))
    {
        retString = "fna";
    }
    else if (detName == string("ForwardAllCalls"))
    {
        retString = "cfa";
    }
    else if (detName == string("CallBlocking"))
    {
        retString = "clbl";
    }
    else if (detName == string("CallForwardBusy"))
    {
        retString = "cfb";
    }

    return retString;

}
