
/* ====================================================================
 * The Vovida Software License, Version 1.0
 *
 * Copyright (c) 1999, 2000 Vovida Networks, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by Vovida Networks,
 *        Inc. (http://www.vovida.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must 
 *    not be used to endorse or promote products derived from this 
 *    software without prior written permission. For written permission, 
 *    please contact vocal@vovida.org.
 *
 * 5. Products derived from this software may not be called "VOCAL",
 *    nor may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL VOVIDA NETWORKS, INC. OR ITS 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 
 * This software consists of voluntary contributions made by Vovida 
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see 
 * <http://www.vovida.org/>.
 *
 */

#ifndef VPP_DEF_H
#define  VPP_DEF_H

static const char* const Vpp_def_h_Version =
    "$Id: Vpp_def.h,v 1.6 2000/09/20 21:38:49 cvs Exp $";
#define VPP_VERSION      "VPP/1.0" // Vovida Provisioning Protocol
#define CONT_LENGTH      "Content-Length:"
#define VPPREQ_BUF_LEN   56
#define URL_LENGTH       100
#define CONT_STR_LENGTH  56
#define VPPVER_LENGTH    56

// Messages accepted from client for manipulating data
#define GET_REQ          "GET"         // get an item
#define PUT_REQ          "PUT"         // put an item
#define LIST_REQ         "LIST"        // list items in a group
#define NLIST_REQ        "NLIST"       // list items with content-length
#define DELETE_USER_REQ  "DELETEUSER"  // delete a user (calls many REMOVES)
#define REMOVE_REQ       "REMOVE"      // remove an item

// Register/Unregister for data
#define REGISTER_ITEM_REQ      "REGISTERITEM"
#define REGISTER_GROUP_REQ     "REGISTERGROUP"
#define UNREGISTER_ITEM_REQ    "UNREGISTERITEM"
#define UNREGISTER_GROUP_REQ   "UNREGISTERGROUP"

// Mesages sent to client
#define UPDATEITEM_REQ     "UPDATEITEM"
#define UPDATEGROUP_REQ    "UPDATEGROUP"
#define DELITEM_REQ        "DELITEM"
#define DELGROUP_REQ       "DELGROUP"

// Administrative and Synchronization messages
#define SYNC_GRLIST_REQ       "SYNCGRLIST"       // get all registrations
#define SYNC_PRLIST_REQ       "SYNCPRLIST"       // put all registrations
#define SYNC_GOOD_REQ         "SYNCGOOD"         // sync finished and good
#define SYNC_GET_REQ          "SYNCGET"          // get a file for sync
#define SYNC_PUT_REQ          "SYNCPUT"          // put a file for sync
#define SYNC_REGISTER_ITEM_REQ     "SYNCREGISTERITEM"   // add a registration
#define SYNC_REGISTER_GROUP_REQ    "SYNCREGISTERGROUP"  // add a registration
#define SYNC_UNREGISTER_ITEM_REQ   "SYNCUNREGISTERITEM"
#define SYNC_UNREGISTER_GROUP_REQ  "SYNCUNREGISTERGROUP"
#define SYNC_START_REQ        "SYNCSTART"
#define SYNC_STAT_REQ         "SYNCSTAT"
#define SYNC_DEL_REQ          "SYNCDEL"

#endif // VPP_DEF_H
