#!/usr/bin/perl

# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.

# $Id: webconf.cgi,v 1.16.2.1 2002/05/06 22:25:37 bsamson Exp $

use CGI qw/:standard/;
use CGI ':cgi-lib';
use provactions;

# figure out local host IP address

chomp($hostname = `hostname`);
($junk1,$junk2,$junk3,$junk4,@addr) = gethostbyname($hostname);
($a,$b,$c,$d) = unpack('C4', $addr[0]);
$local_ip = "$a.$b.$c.$d";


$script_url = $ENV{SCRIPT_NAME};


# todo:

# need to fix

# SystemConfiguration/GlobalConfigData.xml

# set <redirectReasonInSIP value="true"></redirectReasonInSIP>

# to true not false

# should the software make sure audio files are in the right format
# via sox ?  I think it should.  the right command to fix files which
# are wav files is

# sox voicemail/vmhome/2000/custom.wav -U voicemail/vmhome/2000/a.wav

# need to clean up code -- use more of CGI and be happier

# need to fix actual allinoneconfigure code to not need java.

# 



######################################################################
#                            cgi input / output 
######################################################################


sub make_box {
    my($title, $contents, $local_width) = @_;
    my($text, $width);

    $width = $local_width;

    $text .= "<table bgcolor=\"#000000\" cellpadding=0 cellspacing=2 border=0 width=$width>\n";
    $text .= Tr(td({-width=>"100%", -bgcolor=>"#c0c0ff", fgcolor=>white, align=>center}, (font({-size => "+2"}, b($title)))));
    $text .= "<tr><td>\n";
    $text .= "<table bgcolor=white cellpadding=0 cellspacing=0 border=0  width=100%>\n";
    $text .= Tr(td({-width=>"100%"}, $contents));
    $text .= "</table></tr></td></table>\n";
    return $text;
}


sub checkbox {
    my($name, $checked) = @_;
    my($result) = "<input type=checkbox name=$name value=1";
    if($checked) {
	$result .= " checked";
    }
    $result .= "></input>";
    return $result;
}


sub password {
    my($name, $value) = @_;
    my($result) = "<input type=password name=$name";
    if($value) {
	$result .= " value=\"$value\"";
    }
    $result .= "></input>";
    return $result;
}


sub show_one_user {
    my($userid) = @_;

    my($output);
    my($auth_type);
    my($parameters) = &get_data_one_user($userid);

    if($parameters) {
	$upload_custom_greeting_txt = filefield('uploaded_greeting');
	
	
	$output = start_multipart_form(-method=>"post",
				       -action=>"$script_url");
	$output .= "<input type=hidden name=\"cmd\" value=\"write\">";
	$output .= "<input type=hidden name=\"user\" value=\"$userid\">";
	
	$output .= "<table width=100%>";
	
	$output .= Tr(td("User:"), td($userid));
	$output .= Tr(td("Use password:"), 
		      td(&checkbox("use_passwd", $$parameters{use_passwd})));
	$output .= Tr(td("Password:"), 
		      td(&password("passwd", $$parameters{passwd})));
	$output .= Tr(td("Allow local calls:"), 
		      td(&checkbox("allow_local", $allow_local)));
	$output .= Tr(td("Allow gateway calls:"), 
		      td(&checkbox("allow_gw", $allow_gw)));
	$output .= "</table>";
	
	$output .= "<table width=100% bgcolor=\"#c0c0ff\">";
	$output .= Tr(td("Enable Voicemail:"), 
		      td(&checkbox("enable_vm", $$parameters{enable_vm})));
	$output .= Tr(td("Voicemail Email Address:<BR>(The voicemail will be sent to this email address)"), 
		      td("<input type=text name=\"voicemail_addr\" value=\"$$parameters{voicemail_addr}\"></input>"));
	$output .= Tr(td("Use custom greeting:"), 
		      td(&checkbox("use_custom", $$parameters{use_custom})));
	$output .= Tr(td("Upload custom greeting"), 
		      td($upload_custom_greeting_txt));
	$output .= Tr(td("<input type=reset name=\"_reset\" value=\"Revert\">"),
		      td("<input type=submit name=\"_submit\" value=\"Save\">"));
	$output .= "</table>";
	
	$output .= "</form>";
	
	$output .= "<table width=100% bgcolor=\"#c0c0ff\">";
	$output .= Tr(td({-align=>"right", -colspan=>2},
			 "<a href=\"$script_url\">Return to main menu</a>"));
	$output .= "</table>";
    } else {
	$output = "Unable to find user $userid<p>";
    }
    return $output;
}


sub show_users {
    my($users) = &get_account_list();
    my $user;
    my $text;
    my $count = 0;
    my (@color) = ("#ffffff", "#e0e0ff");

    
    $text .= "<table cellspacing=0 border=0 width=\"100%\">";

    foreach $user (@$users) {
	$text .= Tr({-bgcolor=>$color[$count % 2]}, 
		    td( "<a href=\"$script_url?cmd=show&user=$user\">$user</a>"), 
		   );
	$count = !$count;
    }
#    $text .= Tr({-bgcolor=>$color[$count % 2]}, 
#		    td({-colspan=>2, -align=>"right"}, "<a href=\"$script_url?cmd=adduser\">Add user</a>"));
    $text .= "</table>";
    $text .= "\n";
    return $text;
}


sub select_change_user {
    my($users) = &get_account_list();
    my $user;
    my $text;
    my $count = 0;
    my (@color) = ("#ffffff", "#e0e0ff");

    
    $text .= "<table cellspacing=0 border=0 width=\"100%\">";

    foreach $user (@$users) {
	$text .= Tr({-bgcolor=>$color[$count % 2]}, 
		    td( "<a href=\"$script_url?cmd=show&user=$user\">$user</a>"), 
		   );
	$count = !$count;
    }
#    $text .= Tr({-bgcolor=>$color[$count % 2]}, 
#		    td({-colspan=>2, -align=>"right"}, "<a href=\"$script_url?cmd=adduser\">Add user</a>"));
    $text .= "</table>";
    $text .= "\n";
    return $text;
}


sub select_delete_user {
    my($users) = &get_account_list();
    my $user;
    my $text;
    my $count = 0;
    my (@color) = ("#ffffff", "#e0e0ff");

    
    $text .= "<table cellspacing=0 border=0 width=\"100%\">";

    foreach $user (@$users) {
	$text .= Tr({-bgcolor=>$color[$count % 2]}, 
		    td("<a href=\"$script_url?cmd=delete&user=$user\">Delete $user</a>") 
		   );
	$count = !$count;
    }
    $text .= "</table>";
    $text .= "\n";
    return $text;
}



sub show_gw {
    my($param) = &get_gw_data();

    # get the value from somewhere

    $output = "<form method=post action=\"$script_url\">";
    $output .= "<input type=hidden name=\"cmd\" value=\"writegw\">";

    $output .= "<table width=100%>";

    $output .= Tr(td("Gateway (in form host:port):"), 
		  td("<input type=text name=\"gw_location\" value=\"$$param{gw_location}\"></input>"));

    $output .= Tr(td("<input type=reset name=\"_reset\" value=\"Revert\">"),
		  td("<input type=submit name=\"_submit\" value=\"Save\">"));
    $output .= "</table>";

    $output .= "</form>";

    $output .= "<table width=100% bgcolor=\"#c0c0ff\">";
    $output .= Tr(td({-align=>"right", -colspan=>2},
		     "<a href=\"$script_url\">Return to main menu</a>"));
    $output .= "</table>";
    return $output;
}


sub html_header {
    my($output) = header;
    my($hostname);
    chomp($hostname = `hostname`);
    $output .= "<html><head><title>VOCAL Configuration for $hostname</title></head><body bgcolor=ffffff>";
    $output .= "<TABLE width=\"100%\" border=0 cellspacing=0 cellpadding=0>";
    $output .= Tr(td({-bgcolor=>"#ffd0ff", -align=>center}, "<font size=+4>VOCAL Configuration for $hostname</font>"));
    $output .= Tr(td({-align=>right, -bgcolor=>"#ffd0ff"},
		     &show_actions()
		    ));
    $output .= "<TR><TD>";
    return $output;
}


sub html_footer {
    my($output);

    $output .= "</TD></TR></TABLE>\n";
    $output .= "</BODY></HTML>";
    return $output;
}


sub get_actions {
    my($single_cmd);
    my($cmdarray) = [];

    foreach $single_cmd (sort keys %$cmd) {
	if($$cmd{$single_cmd}{menu}) {
	    $$cmdarray[$$cmd{$single_cmd}{menu} - 1]
	      = "<a href=\"$script_url?cmd=$single_cmd\">$$cmd{$single_cmd}{text}</a>";
	}
    }

    return $cmdarray;
}


sub show_actions {
    my($cmdarray) = &get_actions();
    my($single_output);
    my($output);

    foreach $single_output (@$cmdarray) {
	if($output) {
	    $output .= " | ";
	}
	$output .= $single_output;
    }

    return $output;
}


sub show_actions_table {
    my($cmdarray) = &get_actions();
    my($single_output);
    my($text) = "<table bgcolor=white width=\"100%\">";
    my (@color) = ("#ffffff", "#e0e0ff");
    my($count);

    shift(@$cmdarray);

    foreach $single_output (@$cmdarray) {
	$text .= Tr({-bgcolor=>$color[$count % 2]}, 
		    td( $single_output), 
		   );
	$count = !$count;
    }

    $text .= "</table>";

    return $text;
}


sub inactive_box {
    return &make_box("Provisioning not running", 
		     "VOCAL is not running now.<P>" .
		     "Please make sure that VOCAL is running ". 
		     "before trying to run this system." .
		     "<P><a href=\"$script_url\">" .
		     "Return to main menu</a>", 
		     300);
}

sub command_main {
    print &html_header();
    if(&verify_active()) {
	print &make_box("Choose an action", &show_actions_table(), 200);
    } else {
	print &inactive_box();
    }
    print &html_footer();
}


sub command_changeuser {
    print &html_header();
    if(&verify_active()) {
	print &make_box("Choose user to change", &select_change_user(), 200);
    } else {
	print &inactive_box();
    }
    print &html_footer();
}


sub command_deleteuser {
    print &html_header();
    if(&verify_active()) {
	print &make_box("Choose user to delete", &select_delete_user(), 200);
    } else {
	print &inactive_box();
    }
    print &html_footer();
}


sub command_show {
    print &html_header();
    if(&verify_active()) {
	print &make_box("User " . param('user'), 
			&show_one_user(param('user')), 
			400);
    } else {
	print &inactive_box();
    }
    print &html_footer();
}


sub command_adduser {
    print &html_header();
    my($output);

    $output = "<form method=post action=\"$script_url\">";
    $output .= "<input type=hidden name=\"cmd\" value=\"create\">";
    $output .= "Enter new user id: <input type=text name=\"user\" value=\"$userid\">\n";
    $output .= "<p><input type=submit name=\"_submit\" value=\"Create User\"></input>";
    $output .= "</form>";

    if(&verify_active()) {
	print &make_box("Add user",
			$output,
			400);
    } else {
	print &inactive_box();
    }
    print &html_footer();
}

sub Vars {
    my(@list) = param();
    my($params) = {};
    foreach $item (@list) {
	$$params{$item} = param($item);
    }
    return $params;
}

sub command_create {
    # create the user
    print &html_header();

    $params = Vars;
    
    my($output) = &create_new_user($params);
    
    if($output !~ /failed/i) {
	$output .= "<p>";
	$output .= "<a href=\"$script_url?cmd=show&user=$$params{user}\">";
	$output .= "Go to to user page</a>";
	$output .= "<br>";
    }
	
    $output .= "<a href=\"$script_url\">";
    $output .= "Return to main menu</a>";
	
    print &make_box("Trying to create user \"" . param('user') .'"',
		    $output,
		    400);

    print &html_footer();
}


sub command_write {
    print &html_header();

    $params = Vars;
    
    my($output) = &update_one_user($params);
    
    $output .= "<p>";
    $output .= "<a href=\"$script_url?cmd=show&user=$$params{user}\">";
    $output .= "Return to user page</a>";
    
    $output .= "<br><a href=\"$script_url\">";
    $output .= "Return to main menu</a>";
    
    print &make_box("Trying to save user \"" . param('user') .'"',
		    $output,
		    400);
    print &html_footer();
}


sub command_delete {
    print &html_header();

    $params = Vars;
    
    my($output) = &delete_one_user($params);
    
    $output .= "<p>";
    $output .= "<a href=\"$script_url\">";
    $output .= "Return to main page</a>";
    
    print &make_box("Trying to delete user \"" . param('user') .'"',
		    $output,
		    400);
    print &html_footer();
}


sub command_setvmdialplan {
    print &html_header();
    $params = Vars;
    my($output) = &set_vm_dialplan();
    
    $output .= "<p>";
    $output .= "<a href=\"$script_url\">";
    $output .= "Return to main page</a>";

    print &make_box("Trying to create VM dialplan",
		    $output,
		    400);
    print &html_footer();
}


sub command_writegw {
    print &html_header();

    $params = Vars;
    
    my($output) = &update_gw($params);
    
    $output .= "<p><a href=\"$script_url\">";
    $output .= "Return to main menu</a>";
    
    print &make_box("Trying to write Gateway",
		    $output,
		    400);
    print &html_footer();

}


sub command_showgw {
    print &html_header();

    if(&verify_active()) {
	$params = Vars;
	print &make_box("Change Gateway",
			&show_gw(),
			400);
    } else {
	print &inactive_box();
    }
    print &html_footer();

}

sub command_showstatus {
    print &html_header();
    my($output)="<table width=\"100%\" border=\"undef\">";
    $output .= Tr({ -align=>LEFT}, th(['Process', 'Port', 'PID']));

    open STATUS, "../bin/vocalctl status |" or die "can't fork";
    while (<STATUS>) {
      ($proc, $port, $pid) = split;
      if ( ($proc eq "ps") || ($proc eq "vmserver") )
      {
        $pid = $port;
        $port = "";
      }
      $output .= Tr({ -align=>LEFT }, td([$proc, $port, $pid]));
    }
    $output .= "</table>";
    if(&verify_active()) {
	print &make_box("System Status",
			$output,
			400);
    } else {
	print &inactive_box();
    }
    print &html_footer();
}



$cmd = {
	main => { code => \&command_main, text => "Main menu", menu => 1 },
	changeuser => { code => \&command_changeuser, text => "Change user", menu => 2 },
	deleteuser => { code => \&command_deleteuser, text => "Delete user", menu => 3 },
	adduser => { code => \&command_adduser, text => "Add user", menu => 4 },
#	setvmdialplan => { code => \&command_setvmdialplan, text => "Enable VM dialplan", menu => 5 },
	showgw => {  code => \&command_showgw, text => "Change gateway", menu => 5 },

	showstatus => {  code => \&command_showstatus, text => "System Status", menu => 6 },
	show => { code => \&command_show, text => "Show" },
	write => { code => \&command_write, text => "Write" },
	create => { code => \&command_create, text => "Create" },
	delete => { code => \&command_delete, text => "Delete" },
	writegw => { code => \&command_writegw, text => "Writegw" },
       };

if(param()) {
    $command = param('cmd');
} else {
    $command = "main";
}

$cmd_to_exec = $$cmd{$command}{code};

if(!$cmd_to_exec) {
    $cmd_to_exec = \&command_main;
}

&{$cmd_to_exec}();
