#include "B2bUa.hxx"
#include "B2bCmdLine.hxx"
#include "B2bConfig.hxx"
int
main(const int argc, const char**argv)
{
    try
    {
        string applName = "B2bUa";
        cpLogSetLabel( applName.c_str() );
        B2bCmdLine::instance( argc, argv);

        //Set it up from provisioning
        string configFile = B2bCmdLine::instance()->getString( "configFile");
        if(configFile != B2bCmdLine::USE_PROVISIONING)
        {
            cpLog(LOG_INFO, "Using config file for B2b config data");
            B2bConfig::instance().initFromFile(configFile);
        }
        else
        {
            cpLog(LOG_INFO, "Using provisioning for B2b config data");
            string psHost1= B2bCmdLine::instance()->getString( "pshostname");
            string psHost2= B2bCmdLine::instance()->getString( "psbackuphostname");
            int psPort1 = B2bCmdLine::instance()->getInt("psremoteport");
            int psPort2 = B2bCmdLine::instance()->getInt("psbackupremoteport");
            int sipPort = B2bCmdLine::instance()->getInt( "sipport" );
            B2bConfig::instance().initFromProvisioning(psHost1.c_str(), psPort1, psHost2.c_str(), psPort2, sipPort);
        }
        B2bConfig& cfg = B2bConfig::instance();
        cerr << "Config data" << cfg << endl;
        B2bUa& myB2bUa  = B2bUa::instance(applName, cfg.getLocalSipPort(), true, false);
        
        myB2bUa.run();
    }
    catch(VException& e)
    {
        cerr << "Caught exception, termination application. Reason ";
        cerr << e.getDescription().c_str() << endl;
    }
}
