#ifndef VovidaSipStack_Hxx
#define VovidaSipStack_Hxx

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

static const char* const VovidaSipStackVersion =
    "$Id: VovidaSipStack.hxx,v 1.14 2002/03/19 21:39:56 jason Exp $";

/*********************************************************************
 
 $Id: VovidaSipStack.hxx,v 1.14 2002/03/19 21:39:56 jason Exp $
 
 *********************************************************************
 
  Copyright 2000 Vovida Networks, Inc.  All Rights Reserved.
 
 *********************************************************************
 
 $Log: VovidaSipStack.hxx,v $
 Revision 1.14  2002/03/19 21:39:56  jason
 put all sip/sipstack and sip/base code into the Vocal namespace

 Revision 1.13  2001/09/20 00:41:44  bko
 fixes for the great conversion operator removal from Data

 Revision 1.12  2001/05/05 01:00:28  bhadoria
 cleaned up the files not it use in new stack design.

 Revision 1.11  2001/05/03 17:46:42  cvs
 re-pertinizing

 Revision 1.9  2001/04/27 11:02:45  bko
 merged changes for performance from PERF-03-15

 Revision 1.8.6.1  2001/04/17 01:17:30  bhadoria
 new sip transceiver/filter/databases ...

 Revision 1.8  2000/12/18 23:45:27  bko
 fix typo of ,000 instead of ,000 in the code

 Revision 1.7  2000/09/20 08:02:26  cvs
 global format change

 Revision 1.6  2000/08/17 20:55:19  bogawa
 changes to make header files compile by themselves
 
 Revision 1.5  2000/08/11 00:29:16  bogawa
 updated the Vovida Software License to its current form
 
 Revision 1.4  2000/08/10 11:13:48  bogawa
 add Vovida Software License v1 to files
 
 Revision 1.3  2000/07/30 21:37:09  cullen
 update id var
 
 Revision 1.2  2000/06/24 00:44:29  hyu
 Merging BRANCH_NEWSIPTRANSCEIVER into HEAD.
 
 Revision 1.1.2.1  2000/06/17 01:44:21  bogawa
 make sure that UA compiles again with the new SipTransceiver, as well as minor restructuring
 
 Revision 1.1  2000/05/28 21:26:23  chok
 Base code changes for new user agent
 
 
 ********************************************************************/


#include "SipTransceiver.hxx"

namespace Vocal
{
    
typedef SipTransceiver SipTransceiverFilter;
typedef SipTransceiver VovidaSipStack;
    
} // namespace Vocal

/* Local Variables: */
/* c-file-style: "stroustrup" */
/* indent-tabs-mode: nil */
/* c-file-offsets: ((access-label . -) (inclass . ++)) */
/* c-basic-offset: 4 */
/* End: */
#endif
